#include "gptriangle.h"

void gptriangle::set(int integrationorder, std::vector<double>& coordinates, std::vector<double>& weights)
{

    switch (integrationorder)
    {
        case 0 ... 1:
            
            coordinates = {1.0/3.0,1.0/3.0,0};
            weights = {0.5};

            break;
            
        case 2:
            
            coordinates.resize(3*3);
            weights.resize(3);
            
            coordinates[0] = 1.0/6.0;
            coordinates[1] = 1.0/6.0;
            coordinates[3] = 2.0/3.0;
            coordinates[4] = 1.0/6.0;
            coordinates[6] = 1.0/6.0;
            coordinates[7] = 2.0/3.0;
            weights[0] = 1.0/6.0;
            weights[1] = 1.0/6.0;
            weights[2] = 1.0/6.0;
            
            break;
            
        case 3:
            
            coordinates.resize(4*3);
            weights.resize(4);
            
            coordinates[0] = 1.0/3.0;
            coordinates[1] = 1.0/3.0;
            coordinates[3] = 0.2;
            coordinates[4] = 0.2;
            coordinates[6] = 0.2;
            coordinates[7] = 0.6;
            coordinates[9] = 0.6;
            coordinates[10] = 0.2;
            weights[0] = -27.0/96.0;
            weights[1] = 25.0/96.0;
            weights[2] = 25.0/96.0;
            weights[3] = 25.0/96.0;
            
            break;
            
        case 4:
            
            coordinates.resize(6*3);
            weights.resize(6);

            coordinates[0] = 0.445948490915965;
            coordinates[1] = 0.445948490915965;
            coordinates[2] = 0;
            coordinates[3] = 0.445948490915965;
            coordinates[4] = 0.10810301816807;
            coordinates[5] = 0;
            coordinates[6] = 0.10810301816807;
            coordinates[7] = 0.445948490915965;
            coordinates[8] = 0;
            coordinates[9] = 0.091576213509771007;
            coordinates[10] = 0.091576213509771007;
            coordinates[11] = 0;
            coordinates[12] = 0.091576213509771007;
            coordinates[13] = 0.81684757298045896;
            coordinates[14] = 0;
            coordinates[15] = 0.81684757298045896;
            coordinates[16] = 0.091576213509771007;
            coordinates[17] = 0;

            weights[0] = 0.111690794839005;
            weights[1] = 0.111690794839005;
            weights[2] = 0.111690794839005;
            weights[3] = 0.054975871827660998;
            weights[4] = 0.054975871827660998;
            weights[5] = 0.054975871827660998;

            break;

        case 5:
            
            coordinates.resize(7*3);
            weights.resize(7);

            coordinates[0] = 0.33333333333333298;
            coordinates[1] = 0.33333333333333298;
            coordinates[2] = 0;
            coordinates[3] = 0.470142064105115;
            coordinates[4] = 0.470142064105115;
            coordinates[5] = 0;
            coordinates[6] = 0.470142064105115;
            coordinates[7] = 0.059715871789770003;
            coordinates[8] = 0;
            coordinates[9] = 0.059715871789770003;
            coordinates[10] = 0.470142064105115;
            coordinates[11] = 0;
            coordinates[12] = 0.101286507323456;
            coordinates[13] = 0.101286507323456;
            coordinates[14] = 0;
            coordinates[15] = 0.101286507323456;
            coordinates[16] = 0.79742698535308698;
            coordinates[17] = 0;
            coordinates[18] = 0.79742698535308698;
            coordinates[19] = 0.101286507323456;
            coordinates[20] = 0;

            weights[0] = 0.1125;
            weights[1] = 0.066197076394252999;
            weights[2] = 0.066197076394252999;
            weights[3] = 0.066197076394252999;
            weights[4] = 0.062969590272414;
            weights[5] = 0.062969590272414;
            weights[6] = 0.062969590272414;

            break;
            
        case 6:
            
            coordinates.resize(12*3);
            weights.resize(12);

            coordinates[0] = 0.24928674517091001;
            coordinates[1] = 0.24928674517091001;
            coordinates[2] = 0;
            coordinates[3] = 0.24928674517091001;
            coordinates[4] = 0.50142650965817903;
            coordinates[5] = 0;
            coordinates[6] = 0.50142650965817903;
            coordinates[7] = 0.24928674517091001;
            coordinates[8] = 0;
            coordinates[9] = 0.063089014491502005;
            coordinates[10] = 0.063089014491502005;
            coordinates[11] = 0;
            coordinates[12] = 0.063089014491502005;
            coordinates[13] = 0.87382197101699599;
            coordinates[14] = 0;
            coordinates[15] = 0.87382197101699599;
            coordinates[16] = 0.063089014491502005;
            coordinates[17] = 0;
            coordinates[18] = 0.310352451033785;
            coordinates[19] = 0.636502499121399;
            coordinates[20] = 0;
            coordinates[21] = 0.636502499121399;
            coordinates[22] = 0.053145049844816002;
            coordinates[23] = 0;
            coordinates[24] = 0.053145049844816002;
            coordinates[25] = 0.310352451033785;
            coordinates[26] = 0;
            coordinates[27] = 0.310352451033785;
            coordinates[28] = 0.053145049844816002;
            coordinates[29] = 0;
            coordinates[30] = 0.636502499121399;
            coordinates[31] = 0.310352451033785;
            coordinates[32] = 0;
            coordinates[33] = 0.053145049844816002;
            coordinates[34] = 0.636502499121399;
            coordinates[35] = 0;

            weights[0] = 0.058393137863188997;
            weights[1] = 0.058393137863188997;
            weights[2] = 0.058393137863188997;
            weights[3] = 0.025422453185103999;
            weights[4] = 0.025422453185103999;
            weights[5] = 0.025422453185103999;
            weights[6] = 0.041425537809187001;
            weights[7] = 0.041425537809187001;
            weights[8] = 0.041425537809187001;
            weights[9] = 0.041425537809187001;
            weights[10] = 0.041425537809187001;
            weights[11] = 0.041425537809187001;

            break;
            
        case 7:

            coordinates.resize(13*3);
            weights.resize(13);

            coordinates[0] = 0.33333333333333298;
            coordinates[1] = 0.33333333333333298;
            coordinates[2] = 0;
            coordinates[3] = 0.26034596607903998;
            coordinates[4] = 0.26034596607903998;
            coordinates[5] = 0;
            coordinates[6] = 0.26034596607903998;
            coordinates[7] = 0.47930806784191998;
            coordinates[8] = 0;
            coordinates[9] = 0.47930806784191998;
            coordinates[10] = 0.26034596607903998;
            coordinates[11] = 0;
            coordinates[12] = 0.065130102902216006;
            coordinates[13] = 0.065130102902216006;
            coordinates[14] = 0;
            coordinates[15] = 0.065130102902216006;
            coordinates[16] = 0.86973979419556802;
            coordinates[17] = 0;
            coordinates[18] = 0.86973979419556802;
            coordinates[19] = 0.065130102902216006;
            coordinates[20] = 0;
            coordinates[21] = 0.31286549600487401;
            coordinates[22] = 0.63844418856981;
            coordinates[23] = 0;
            coordinates[24] = 0.63844418856981;
            coordinates[25] = 0.048690315425316003;
            coordinates[26] = 0;
            coordinates[27] = 0.048690315425316003;
            coordinates[28] = 0.31286549600487401;
            coordinates[29] = 0;
            coordinates[30] = 0.31286549600487401;
            coordinates[31] = 0.048690315425316003;
            coordinates[32] = 0;
            coordinates[33] = 0.63844418856981;
            coordinates[34] = 0.31286549600487401;
            coordinates[35] = 0;
            coordinates[36] = 0.048690315425316003;
            coordinates[37] = 0.63844418856981;
            coordinates[38] = 0;

            weights[0] = -0.074785022233840995;
            weights[1] = 0.087807628716603997;
            weights[2] = 0.087807628716603997;
            weights[3] = 0.087807628716603997;
            weights[4] = 0.026673617804419;
            weights[5] = 0.026673617804419;
            weights[6] = 0.026673617804419;
            weights[7] = 0.038556880445127999;
            weights[8] = 0.038556880445127999;
            weights[9] = 0.038556880445127999;
            weights[10] = 0.038556880445127999;
            weights[11] = 0.038556880445127999;
            weights[12] = 0.038556880445127999;

            break;

        case 8:

            coordinates.resize(16*3);
            weights.resize(16);

            coordinates[0] = 0.33333333333333298;
            coordinates[1] = 0.33333333333333298;
            coordinates[2] = 0;
            coordinates[3] = 0.45929258829272301;
            coordinates[4] = 0.45929258829272301;
            coordinates[5] = 0;
            coordinates[6] = 0.45929258829272301;
            coordinates[7] = 0.081414823414554;
            coordinates[8] = 0;
            coordinates[9] = 0.081414823414554;
            coordinates[10] = 0.45929258829272301;
            coordinates[11] = 0;
            coordinates[12] = 0.17056930775175999;
            coordinates[13] = 0.17056930775175999;
            coordinates[14] = 0;
            coordinates[15] = 0.17056930775175999;
            coordinates[16] = 0.65886138449648002;
            coordinates[17] = 0;
            coordinates[18] = 0.65886138449648002;
            coordinates[19] = 0.17056930775175999;
            coordinates[20] = 0;
            coordinates[21] = 0.050547228317030998;
            coordinates[22] = 0.050547228317030998;
            coordinates[23] = 0;
            coordinates[24] = 0.050547228317030998;
            coordinates[25] = 0.89890554336593798;
            coordinates[26] = 0;
            coordinates[27] = 0.89890554336593798;
            coordinates[28] = 0.050547228317030998;
            coordinates[29] = 0;
            coordinates[30] = 0.263112829634638;
            coordinates[31] = 0.72849239295540402;
            coordinates[32] = 0;
            coordinates[33] = 0.72849239295540402;
            coordinates[34] = 0.0083947774099580007;
            coordinates[35] = 0;
            coordinates[36] = 0.0083947774099580007;
            coordinates[37] = 0.263112829634638;
            coordinates[38] = 0;
            coordinates[39] = 0.263112829634638;
            coordinates[40] = 0.0083947774099580007;
            coordinates[41] = 0;
            coordinates[42] = 0.72849239295540402;
            coordinates[43] = 0.263112829634638;
            coordinates[44] = 0;
            coordinates[45] = 0.0083947774099580007;
            coordinates[46] = 0.72849239295540402;
            coordinates[47] = 0;

            weights[0] = 0.072157803838894002;
            weights[1] = 0.047545817133642997;
            weights[2] = 0.047545817133642997;
            weights[3] = 0.047545817133642997;
            weights[4] = 0.051608685267358997;
            weights[5] = 0.051608685267358997;
            weights[6] = 0.051608685267358997;
            weights[7] = 0.016229248811599001;
            weights[8] = 0.016229248811599001;
            weights[9] = 0.016229248811599001;
            weights[10] = 0.013615157087217;
            weights[11] = 0.013615157087217;
            weights[12] = 0.013615157087217;
            weights[13] = 0.013615157087217;
            weights[14] = 0.013615157087217;
            weights[15] = 0.013615157087217;

            break;

        case 9:

            coordinates.resize(19*3);
            weights.resize(19);

            coordinates[0] = 0.33333333333300003;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.48968251919900002;
            coordinates[4] = 0.48968251919900002;
            coordinates[5] = 0;
            coordinates[6] = 0.48968251919900002;
            coordinates[7] = 0.020634961602500002;
            coordinates[8] = 0;
            coordinates[9] = 0.020634961602500002;
            coordinates[10] = 0.48968251919900002;
            coordinates[11] = 0;
            coordinates[12] = 0.43708959149299997;
            coordinates[13] = 0.43708959149299997;
            coordinates[14] = 0;
            coordinates[15] = 0.43708959149299997;
            coordinates[16] = 0.125820817014;
            coordinates[17] = 0;
            coordinates[18] = 0.125820817014;
            coordinates[19] = 0.43708959149299997;
            coordinates[20] = 0;
            coordinates[21] = 0.188203535619;
            coordinates[22] = 0.188203535619;
            coordinates[23] = 0;
            coordinates[24] = 0.188203535619;
            coordinates[25] = 0.62359292876200001;
            coordinates[26] = 0;
            coordinates[27] = 0.62359292876200001;
            coordinates[28] = 0.188203535619;
            coordinates[29] = 0;
            coordinates[30] = 0.044729513394500001;
            coordinates[31] = 0.044729513394500001;
            coordinates[32] = 0;
            coordinates[33] = 0.044729513394500001;
            coordinates[34] = 0.91054097321100003;
            coordinates[35] = 0;
            coordinates[36] = 0.91054097321100003;
            coordinates[37] = 0.044729513394500001;
            coordinates[38] = 0;
            coordinates[39] = 0.22196298916099999;
            coordinates[40] = 0.74119859878399996;
            coordinates[41] = 0;
            coordinates[42] = 0.74119859878399996;
            coordinates[43] = 0.036838412054700002;
            coordinates[44] = 0;
            coordinates[45] = 0.036838412054700002;
            coordinates[46] = 0.22196298916099999;
            coordinates[47] = 0;
            coordinates[48] = 0.22196298916099999;
            coordinates[49] = 0.036838412054700002;
            coordinates[50] = 0;
            coordinates[51] = 0.74119859878399996;
            coordinates[52] = 0.22196298916099999;
            coordinates[53] = 0;
            coordinates[54] = 0.036838412054700002;
            coordinates[55] = 0.74119859878399996;
            coordinates[56] = 0;

            weights[0] = 0.048567898141400001;
            weights[1] = 0.015667350113549999;
            weights[2] = 0.015667350113549999;
            weights[3] = 0.015667350113549999;
            weights[4] = 0.038913770502399997;
            weights[5] = 0.038913770502399997;
            weights[6] = 0.038913770502399997;
            weights[7] = 0.039823869463600003;
            weights[8] = 0.039823869463600003;
            weights[9] = 0.039823869463600003;
            weights[10] = 0.012788837829349999;
            weights[11] = 0.012788837829349999;
            weights[12] = 0.012788837829349999;
            weights[13] = 0.02164176968865;
            weights[14] = 0.02164176968865;
            weights[15] = 0.02164176968865;
            weights[16] = 0.02164176968865;
            weights[17] = 0.02164176968865;
            weights[18] = 0.02164176968865;

            break;

        case 10:

            coordinates.resize(25*3);
            weights.resize(25);

            coordinates[0] = 0.33333333333300003;
            coordinates[1] = 0.33333333333300003;
            coordinates[2] = 0;
            coordinates[3] = 0.48557763338400001;
            coordinates[4] = 0.48557763338400001;
            coordinates[5] = 0;
            coordinates[6] = 0.48557763338400001;
            coordinates[7] = 0.028844733232699999;
            coordinates[8] = 0;
            coordinates[9] = 0.028844733232699999;
            coordinates[10] = 0.48557763338400001;
            coordinates[11] = 0;
            coordinates[12] = 0.109481575485;
            coordinates[13] = 0.109481575485;
            coordinates[14] = 0;
            coordinates[15] = 0.109481575485;
            coordinates[16] = 0.78103684903000004;
            coordinates[17] = 0;
            coordinates[18] = 0.78103684903000004;
            coordinates[19] = 0.109481575485;
            coordinates[20] = 0;
            coordinates[21] = 0.307939838764;
            coordinates[22] = 0.55035294182100003;
            coordinates[23] = 0;
            coordinates[24] = 0.55035294182100003;
            coordinates[25] = 0.141707219415;
            coordinates[26] = 0;
            coordinates[27] = 0.141707219415;
            coordinates[28] = 0.307939838764;
            coordinates[29] = 0;
            coordinates[30] = 0.307939838764;
            coordinates[31] = 0.141707219415;
            coordinates[32] = 0;
            coordinates[33] = 0.55035294182100003;
            coordinates[34] = 0.307939838764;
            coordinates[35] = 0;
            coordinates[36] = 0.141707219415;
            coordinates[37] = 0.55035294182100003;
            coordinates[38] = 0;
            coordinates[39] = 0.24667256064000001;
            coordinates[40] = 0.72832390459700003;
            coordinates[41] = 0;
            coordinates[42] = 0.72832390459700003;
            coordinates[43] = 0.025003534762700001;
            coordinates[44] = 0;
            coordinates[45] = 0.025003534762700001;
            coordinates[46] = 0.24667256064000001;
            coordinates[47] = 0;
            coordinates[48] = 0.24667256064000001;
            coordinates[49] = 0.025003534762700001;
            coordinates[50] = 0;
            coordinates[51] = 0.72832390459700003;
            coordinates[52] = 0.24667256064000001;
            coordinates[53] = 0;
            coordinates[54] = 0.025003534762700001;
            coordinates[55] = 0.72832390459700003;
            coordinates[56] = 0;
            coordinates[57] = 0.066803251012199999;
            coordinates[58] = 0.92365593358700004;
            coordinates[59] = 0;
            coordinates[60] = 0.92365593358700004;
            coordinates[61] = 0.0095408154003000008;
            coordinates[62] = 0;
            coordinates[63] = 0.0095408154003000008;
            coordinates[64] = 0.066803251012199999;
            coordinates[65] = 0;
            coordinates[66] = 0.066803251012199999;
            coordinates[67] = 0.0095408154003000008;
            coordinates[68] = 0;
            coordinates[69] = 0.92365593358700004;
            coordinates[70] = 0.066803251012199999;
            coordinates[71] = 0;
            coordinates[72] = 0.0095408154003000008;
            coordinates[73] = 0.92365593358700004;
            coordinates[74] = 0;

            weights[0] = 0.045408995191400001;
            weights[1] = 0.018362978878249999;
            weights[2] = 0.018362978878249999;
            weights[3] = 0.018362978878249999;
            weights[4] = 0.02266052971775;
            weights[5] = 0.02266052971775;
            weights[6] = 0.02266052971775;
            weights[7] = 0.036378958422700003;
            weights[8] = 0.036378958422700003;
            weights[9] = 0.036378958422700003;
            weights[10] = 0.036378958422700003;
            weights[11] = 0.036378958422700003;
            weights[12] = 0.036378958422700003;
            weights[13] = 0.01416362126555;
            weights[14] = 0.01416362126555;
            weights[15] = 0.01416362126555;
            weights[16] = 0.01416362126555;
            weights[17] = 0.01416362126555;
            weights[18] = 0.01416362126555;
            weights[19] = 0.0047108334818500002;
            weights[20] = 0.0047108334818500002;
            weights[21] = 0.0047108334818500002;
            weights[22] = 0.0047108334818500002;
            weights[23] = 0.0047108334818500002;
            weights[24] = 0.0047108334818500002;

            break;

        case 11:

            coordinates.resize(27*3);
            weights.resize(27);

            coordinates[0] = 0.53461104827100003;
            coordinates[1] = 0.53461104827100003;
            coordinates[2] = 0;
            coordinates[3] = -0.069222096541499994;
            coordinates[4] = 0.53461104827100003;
            coordinates[5] = 0;
            coordinates[6] = 0.53461104827100003;
            coordinates[7] = -0.069222096541499994;
            coordinates[8] = 0;
            coordinates[9] = 0.39896930296599997;
            coordinates[10] = 0.39896930296599997;
            coordinates[11] = 0;
            coordinates[12] = 0.202061394068;
            coordinates[13] = 0.39896930296599997;
            coordinates[14] = 0;
            coordinates[15] = 0.39896930296599997;
            coordinates[16] = 0.202061394068;
            coordinates[17] = 0;
            coordinates[18] = 0.203309900431;
            coordinates[19] = 0.203309900431;
            coordinates[20] = 0;
            coordinates[21] = 0.59338019913700002;
            coordinates[22] = 0.203309900431;
            coordinates[23] = 0;
            coordinates[24] = 0.203309900431;
            coordinates[25] = 0.59338019913700002;
            coordinates[26] = 0;
            coordinates[27] = 0.119350912283;
            coordinates[28] = 0.119350912283;
            coordinates[29] = 0;
            coordinates[30] = 0.761298175435;
            coordinates[31] = 0.119350912283;
            coordinates[32] = 0;
            coordinates[33] = 0.119350912283;
            coordinates[34] = 0.761298175435;
            coordinates[35] = 0;
            coordinates[36] = 0.032364948111300001;
            coordinates[37] = 0.032364948111300001;
            coordinates[38] = 0;
            coordinates[39] = 0.93527010377700004;
            coordinates[40] = 0.032364948111300001;
            coordinates[41] = 0;
            coordinates[42] = 0.032364948111300001;
            coordinates[43] = 0.93527010377700004;
            coordinates[44] = 0;
            coordinates[45] = 0.59320121342800003;
            coordinates[46] = 0.35662064826099998;
            coordinates[47] = 0;
            coordinates[48] = 0.050178138310499998;
            coordinates[49] = 0.59320121342800003;
            coordinates[50] = 0;
            coordinates[51] = 0.35662064826099998;
            coordinates[52] = 0.050178138310499998;
            coordinates[53] = 0;
            coordinates[54] = 0.050178138310499998;
            coordinates[55] = 0.35662064826099998;
            coordinates[56] = 0;
            coordinates[57] = 0.35662064826099998;
            coordinates[58] = 0.59320121342800003;
            coordinates[59] = 0;
            coordinates[60] = 0.59320121342800003;
            coordinates[61] = 0.050178138310499998;
            coordinates[62] = 0;
            coordinates[63] = 0.80748900316000005;
            coordinates[64] = 0.171488980304;
            coordinates[65] = 0;
            coordinates[66] = 0.021022016536199999;
            coordinates[67] = 0.80748900316000005;
            coordinates[68] = 0;
            coordinates[69] = 0.171488980304;
            coordinates[70] = 0.021022016536199999;
            coordinates[71] = 0;
            coordinates[72] = 0.021022016536199999;
            coordinates[73] = 0.171488980304;
            coordinates[74] = 0;
            coordinates[75] = 0.171488980304;
            coordinates[76] = 0.80748900316000005;
            coordinates[77] = 0;
            coordinates[78] = 0.80748900316000005;
            coordinates[79] = 0.021022016536199999;
            coordinates[80] = 0;

            weights[0] = 0.00046350316448000002;
            weights[1] = 0.00046350316448000002;
            weights[2] = 0.00046350316448000002;
            weights[3] = 0.038574767457400003;
            weights[4] = 0.038574767457400003;
            weights[5] = 0.038574767457400003;
            weights[6] = 0.029661488690400001;
            weights[7] = 0.029661488690400001;
            weights[8] = 0.029661488690400001;
            weights[9] = 0.018092270251700002;
            weights[10] = 0.018092270251700002;
            weights[11] = 0.018092270251700002;
            weights[12] = 0.0068298655013499998;
            weights[13] = 0.0068298655013499998;
            weights[14] = 0.0068298655013499998;
            weights[15] = 0.026168555981099999;
            weights[16] = 0.026168555981099999;
            weights[17] = 0.026168555981099999;
            weights[18] = 0.026168555981099999;
            weights[19] = 0.026168555981099999;
            weights[20] = 0.026168555981099999;
            weights[21] = 0.010353829819549999;
            weights[22] = 0.010353829819549999;
            weights[23] = 0.010353829819549999;
            weights[24] = 0.010353829819549999;
            weights[25] = 0.010353829819549999;
            weights[26] = 0.010353829819549999;

            break;

        case 12:

            coordinates.resize(33*3);
            weights.resize(33);

            coordinates[0] = 0.48821738977399998;
            coordinates[1] = 0.48821738977399998;
            coordinates[2] = 0;
            coordinates[3] = 0.48821738977399998;
            coordinates[4] = 0.023565220452400001;
            coordinates[5] = 0;
            coordinates[6] = 0.023565220452400001;
            coordinates[7] = 0.48821738977399998;
            coordinates[8] = 0;
            coordinates[9] = 0.43972439229400001;
            coordinates[10] = 0.43972439229400001;
            coordinates[11] = 0;
            coordinates[12] = 0.43972439229400001;
            coordinates[13] = 0.120551215411;
            coordinates[14] = 0;
            coordinates[15] = 0.120551215411;
            coordinates[16] = 0.43972439229400001;
            coordinates[17] = 0;
            coordinates[18] = 0.27121038501200001;
            coordinates[19] = 0.27121038501200001;
            coordinates[20] = 0;
            coordinates[21] = 0.27121038501200001;
            coordinates[22] = 0.45757922997599998;
            coordinates[23] = 0;
            coordinates[24] = 0.45757922997599998;
            coordinates[25] = 0.27121038501200001;
            coordinates[26] = 0;
            coordinates[27] = 0.127576145542;
            coordinates[28] = 0.127576145542;
            coordinates[29] = 0;
            coordinates[30] = 0.127576145542;
            coordinates[31] = 0.74484770891700003;
            coordinates[32] = 0;
            coordinates[33] = 0.74484770891700003;
            coordinates[34] = 0.127576145542;
            coordinates[35] = 0;
            coordinates[36] = 0.021317350453200001;
            coordinates[37] = 0.021317350453200001;
            coordinates[38] = 0;
            coordinates[39] = 0.021317350453200001;
            coordinates[40] = 0.95736529909400003;
            coordinates[41] = 0;
            coordinates[42] = 0.95736529909400003;
            coordinates[43] = 0.021317350453200001;
            coordinates[44] = 0;
            coordinates[45] = 0.27571326968600002;
            coordinates[46] = 0.60894323577999998;
            coordinates[47] = 0;
            coordinates[48] = 0.60894323577999998;
            coordinates[49] = 0.11534349453499999;
            coordinates[50] = 0;
            coordinates[51] = 0.11534349453499999;
            coordinates[52] = 0.27571326968600002;
            coordinates[53] = 0;
            coordinates[54] = 0.27571326968600002;
            coordinates[55] = 0.11534349453499999;
            coordinates[56] = 0;
            coordinates[57] = 0.60894323577999998;
            coordinates[58] = 0.27571326968600002;
            coordinates[59] = 0;
            coordinates[60] = 0.11534349453499999;
            coordinates[61] = 0.60894323577999998;
            coordinates[62] = 0;
            coordinates[63] = 0.28132558098999999;
            coordinates[64] = 0.69583608678800002;
            coordinates[65] = 0;
            coordinates[66] = 0.69583608678800002;
            coordinates[67] = 0.022838332222300001;
            coordinates[68] = 0;
            coordinates[69] = 0.022838332222300001;
            coordinates[70] = 0.28132558098999999;
            coordinates[71] = 0;
            coordinates[72] = 0.28132558098999999;
            coordinates[73] = 0.022838332222300001;
            coordinates[74] = 0;
            coordinates[75] = 0.69583608678800002;
            coordinates[76] = 0.28132558098999999;
            coordinates[77] = 0;
            coordinates[78] = 0.022838332222300001;
            coordinates[79] = 0.69583608678800002;
            coordinates[80] = 0;
            coordinates[81] = 0.11625191590800001;
            coordinates[82] = 0.85801403354399997;
            coordinates[83] = 0;
            coordinates[84] = 0.85801403354399997;
            coordinates[85] = 0.025734050548300001;
            coordinates[86] = 0;
            coordinates[87] = 0.025734050548300001;
            coordinates[88] = 0.11625191590800001;
            coordinates[89] = 0;
            coordinates[90] = 0.11625191590800001;
            coordinates[91] = 0.025734050548300001;
            coordinates[92] = 0;
            coordinates[93] = 0.85801403354399997;
            coordinates[94] = 0.11625191590800001;
            coordinates[95] = 0;
            coordinates[96] = 0.025734050548300001;
            coordinates[97] = 0.85801403354399997;
            coordinates[98] = 0;

            weights[0] = 0.012865533220250001;
            weights[1] = 0.012865533220250001;
            weights[2] = 0.012865533220250001;
            weights[3] = 0.021846272268999999;
            weights[4] = 0.021846272268999999;
            weights[5] = 0.021846272268999999;
            weights[6] = 0.031429112108949997;
            weights[7] = 0.031429112108949997;
            weights[8] = 0.031429112108949997;
            weights[9] = 0.01739805646535;
            weights[10] = 0.01739805646535;
            weights[11] = 0.01739805646535;
            weights[12] = 0.0030831305257800002;
            weights[13] = 0.0030831305257800002;
            weights[14] = 0.0030831305257800002;
            weights[15] = 0.020185778883200001;
            weights[16] = 0.020185778883200001;
            weights[17] = 0.020185778883200001;
            weights[18] = 0.020185778883200001;
            weights[19] = 0.020185778883200001;
            weights[20] = 0.020185778883200001;
            weights[21] = 0.01117838660115;
            weights[22] = 0.01117838660115;
            weights[23] = 0.01117838660115;
            weights[24] = 0.01117838660115;
            weights[25] = 0.01117838660115;
            weights[26] = 0.01117838660115;
            weights[27] = 0.0086581155543499991;
            weights[28] = 0.0086581155543499991;
            weights[29] = 0.0086581155543499991;
            weights[30] = 0.0086581155543499991;
            weights[31] = 0.0086581155543499991;
            weights[32] = 0.0086581155543499991;

            break;

        case 13:

            coordinates.resize(37*3);
            weights.resize(37);

            coordinates[0] = 0.33333333333330001;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.49504818494000002;
            coordinates[4] = 0.49504818494000002;
            coordinates[5] = 0;
            coordinates[6] = 0.0099036301205899999;
            coordinates[7] = 0.49504818494000002;
            coordinates[8] = 0;
            coordinates[9] = 0.49504818494000002;
            coordinates[10] = 0.0099036301205899999;
            coordinates[11] = 0;
            coordinates[12] = 0.46871663511;
            coordinates[13] = 0.46871663511;
            coordinates[14] = 0;
            coordinates[15] = 0.062566729780899999;
            coordinates[16] = 0.46871663511;
            coordinates[17] = 0;
            coordinates[18] = 0.46871663511;
            coordinates[19] = 0.062566729780899999;
            coordinates[20] = 0;
            coordinates[21] = 0.41452133680100001;
            coordinates[22] = 0.41452133680100001;
            coordinates[23] = 0;
            coordinates[24] = 0.17095732639700001;
            coordinates[25] = 0.41452133680100001;
            coordinates[26] = 0;
            coordinates[27] = 0.41452133680100001;
            coordinates[28] = 0.17095732639700001;
            coordinates[29] = 0;
            coordinates[30] = 0.22939957204299999;
            coordinates[31] = 0.22939957204299999;
            coordinates[32] = 0;
            coordinates[33] = 0.54120085591400002;
            coordinates[34] = 0.22939957204299999;
            coordinates[35] = 0;
            coordinates[36] = 0.22939957204299999;
            coordinates[37] = 0.54120085591400002;
            coordinates[38] = 0;
            coordinates[39] = 0.114424495196;
            coordinates[40] = 0.114424495196;
            coordinates[41] = 0;
            coordinates[42] = 0.771151009607;
            coordinates[43] = 0.114424495196;
            coordinates[44] = 0;
            coordinates[45] = 0.114424495196;
            coordinates[46] = 0.771151009607;
            coordinates[47] = 0;
            coordinates[48] = 0.0248113913635;
            coordinates[49] = 0.0248113913635;
            coordinates[50] = 0;
            coordinates[51] = 0.95037721727299995;
            coordinates[52] = 0.0248113913635;
            coordinates[53] = 0;
            coordinates[54] = 0.0248113913635;
            coordinates[55] = 0.95037721727299995;
            coordinates[56] = 0;
            coordinates[57] = 0.63635117456199997;
            coordinates[58] = 0.26879499705900001;
            coordinates[59] = 0;
            coordinates[60] = 0.094853828379600005;
            coordinates[61] = 0.63635117456199997;
            coordinates[62] = 0;
            coordinates[63] = 0.26879499705900001;
            coordinates[64] = 0.094853828379600005;
            coordinates[65] = 0;
            coordinates[66] = 0.094853828379600005;
            coordinates[67] = 0.26879499705900001;
            coordinates[68] = 0;
            coordinates[69] = 0.26879499705900001;
            coordinates[70] = 0.63635117456199997;
            coordinates[71] = 0;
            coordinates[72] = 0.63635117456199997;
            coordinates[73] = 0.094853828379600005;
            coordinates[74] = 0;
            coordinates[75] = 0.69016915998700001;
            coordinates[76] = 0.29173006673399998;
            coordinates[77] = 0;
            coordinates[78] = 0.018100773278800001;
            coordinates[79] = 0.69016915998700001;
            coordinates[80] = 0;
            coordinates[81] = 0.29173006673399998;
            coordinates[82] = 0.018100773278800001;
            coordinates[83] = 0;
            coordinates[84] = 0.018100773278800001;
            coordinates[85] = 0.29173006673399998;
            coordinates[86] = 0;
            coordinates[87] = 0.29173006673399998;
            coordinates[88] = 0.69016915998700001;
            coordinates[89] = 0;
            coordinates[90] = 0.69016915998700001;
            coordinates[91] = 0.018100773278800001;
            coordinates[92] = 0;
            coordinates[93] = 0.85140953783399997;
            coordinates[94] = 0.12635738549200001;
            coordinates[95] = 0;
            coordinates[96] = 0.022233076674099999;
            coordinates[97] = 0.85140953783399997;
            coordinates[98] = 0;
            coordinates[99] = 0.12635738549200001;
            coordinates[100] = 0.022233076674099999;
            coordinates[101] = 0;
            coordinates[102] = 0.022233076674099999;
            coordinates[103] = 0.12635738549200001;
            coordinates[104] = 0;
            coordinates[105] = 0.12635738549200001;
            coordinates[106] = 0.85140953783399997;
            coordinates[107] = 0;
            coordinates[108] = 0.85140953783399997;
            coordinates[109] = 0.022233076674099999;
            coordinates[110] = 0;

            weights[0] = 0.026260461700400001;
            weights[1] = 0.0056400726046499997;
            weights[2] = 0.0056400726046499997;
            weights[3] = 0.0056400726046499997;
            weights[4] = 0.01571175918125;
            weights[5] = 0.01571175918125;
            weights[6] = 0.01571175918125;
            weights[7] = 0.023536251252100002;
            weights[8] = 0.023536251252100002;
            weights[9] = 0.023536251252100002;
            weights[10] = 0.0236817932682;
            weights[11] = 0.0236817932682;
            weights[12] = 0.0236817932682;
            weights[13] = 0.015583764522899999;
            weights[14] = 0.015583764522899999;
            weights[15] = 0.015583764522899999;
            weights[16] = 0.0039878857325349997;
            weights[17] = 0.0039878857325349997;
            weights[18] = 0.0039878857325349997;
            weights[19] = 0.018424201364349999;
            weights[20] = 0.018424201364349999;
            weights[21] = 0.018424201364349999;
            weights[22] = 0.018424201364349999;
            weights[23] = 0.018424201364349999;
            weights[24] = 0.018424201364349999;
            weights[25] = 0.0087007316519000007;
            weights[26] = 0.0087007316519000007;
            weights[27] = 0.0087007316519000007;
            weights[28] = 0.0087007316519000007;
            weights[29] = 0.0087007316519000007;
            weights[30] = 0.0087007316519000007;
            weights[31] = 0.0077608934195000003;
            weights[32] = 0.0077608934195000003;
            weights[33] = 0.0077608934195000003;
            weights[34] = 0.0077608934195000003;
            weights[35] = 0.0077608934195000003;
            weights[36] = 0.0077608934195000003;

            break;

        case 14:

            coordinates.resize(42*3);
            weights.resize(42);

            coordinates[0] = 0.48896391036199999;
            coordinates[1] = 0.48896391036199999;
            coordinates[2] = 0;
            coordinates[3] = 0.022072179275599998;
            coordinates[4] = 0.48896391036199999;
            coordinates[5] = 0;
            coordinates[6] = 0.48896391036199999;
            coordinates[7] = 0.022072179275599998;
            coordinates[8] = 0;
            coordinates[9] = 0.41764471934000003;
            coordinates[10] = 0.41764471934000003;
            coordinates[11] = 0;
            coordinates[12] = 0.164710561319;
            coordinates[13] = 0.41764471934000003;
            coordinates[14] = 0;
            coordinates[15] = 0.41764471934000003;
            coordinates[16] = 0.164710561319;
            coordinates[17] = 0;
            coordinates[18] = 0.27347752830900002;
            coordinates[19] = 0.27347752830900002;
            coordinates[20] = 0;
            coordinates[21] = 0.45304494338200002;
            coordinates[22] = 0.27347752830900002;
            coordinates[23] = 0;
            coordinates[24] = 0.27347752830900002;
            coordinates[25] = 0.45304494338200002;
            coordinates[26] = 0;
            coordinates[27] = 0.17720553241299999;
            coordinates[28] = 0.17720553241299999;
            coordinates[29] = 0;
            coordinates[30] = 0.64558893517500004;
            coordinates[31] = 0.17720553241299999;
            coordinates[32] = 0;
            coordinates[33] = 0.17720553241299999;
            coordinates[34] = 0.64558893517500004;
            coordinates[35] = 0;
            coordinates[36] = 0.061799883090900003;
            coordinates[37] = 0.061799883090900003;
            coordinates[38] = 0;
            coordinates[39] = 0.87640023381800003;
            coordinates[40] = 0.061799883090900003;
            coordinates[41] = 0;
            coordinates[42] = 0.061799883090900003;
            coordinates[43] = 0.87640023381800003;
            coordinates[44] = 0;
            coordinates[45] = 0.0193909612487;
            coordinates[46] = 0.0193909612487;
            coordinates[47] = 0;
            coordinates[48] = 0.96121807750300003;
            coordinates[49] = 0.0193909612487;
            coordinates[50] = 0;
            coordinates[51] = 0.0193909612487;
            coordinates[52] = 0.96121807750300003;
            coordinates[53] = 0;
            coordinates[54] = 0.77060855477500001;
            coordinates[55] = 0.17226668782099999;
            coordinates[56] = 0;
            coordinates[57] = 0.057124757403599999;
            coordinates[58] = 0.77060855477500001;
            coordinates[59] = 0;
            coordinates[60] = 0.17226668782099999;
            coordinates[61] = 0.057124757403599999;
            coordinates[62] = 0;
            coordinates[63] = 0.057124757403599999;
            coordinates[64] = 0.17226668782099999;
            coordinates[65] = 0;
            coordinates[66] = 0.17226668782099999;
            coordinates[67] = 0.77060855477500001;
            coordinates[68] = 0;
            coordinates[69] = 0.77060855477500001;
            coordinates[70] = 0.057124757403599999;
            coordinates[71] = 0;
            coordinates[72] = 0.57022229084700005;
            coordinates[73] = 0.33686145979600002;
            coordinates[74] = 0;
            coordinates[75] = 0.092916249357000005;
            coordinates[76] = 0.57022229084700005;
            coordinates[77] = 0;
            coordinates[78] = 0.33686145979600002;
            coordinates[79] = 0.092916249357000005;
            coordinates[80] = 0;
            coordinates[81] = 0.092916249357000005;
            coordinates[82] = 0.33686145979600002;
            coordinates[83] = 0;
            coordinates[84] = 0.33686145979600002;
            coordinates[85] = 0.57022229084700005;
            coordinates[86] = 0;
            coordinates[87] = 0.57022229084700005;
            coordinates[88] = 0.092916249357000005;
            coordinates[89] = 0;
            coordinates[90] = 0.68698016780799998;
            coordinates[91] = 0.29837288213599999;
            coordinates[92] = 0;
            coordinates[93] = 0.014646950055700001;
            coordinates[94] = 0.68698016780799998;
            coordinates[95] = 0;
            coordinates[96] = 0.29837288213599999;
            coordinates[97] = 0.014646950055700001;
            coordinates[98] = 0;
            coordinates[99] = 0.014646950055700001;
            coordinates[100] = 0.29837288213599999;
            coordinates[101] = 0;
            coordinates[102] = 0.29837288213599999;
            coordinates[103] = 0.68698016780799998;
            coordinates[104] = 0;
            coordinates[105] = 0.68698016780799998;
            coordinates[106] = 0.014646950055700001;
            coordinates[107] = 0;
            coordinates[108] = 0.87975717136999998;
            coordinates[109] = 0.118974497697;
            coordinates[110] = 0;
            coordinates[111] = 0.00126833093287;
            coordinates[112] = 0.87975717136999998;
            coordinates[113] = 0;
            coordinates[114] = 0.118974497697;
            coordinates[115] = 0.00126833093287;
            coordinates[116] = 0;
            coordinates[117] = 0.00126833093287;
            coordinates[118] = 0.118974497697;
            coordinates[119] = 0;
            coordinates[120] = 0.118974497697;
            coordinates[121] = 0.87975717136999998;
            coordinates[122] = 0;
            coordinates[123] = 0.87975717136999998;
            coordinates[124] = 0.00126833093287;
            coordinates[125] = 0;

            weights[0] = 0.0109417906847;
            weights[1] = 0.0109417906847;
            weights[2] = 0.0109417906847;
            weights[3] = 0.01639417677205;
            weights[4] = 0.01639417677205;
            weights[5] = 0.01639417677205;
            weights[6] = 0.025887052253650001;
            weights[7] = 0.025887052253650001;
            weights[8] = 0.025887052253650001;
            weights[9] = 0.021081294368499998;
            weights[10] = 0.021081294368499998;
            weights[11] = 0.021081294368499998;
            weights[12] = 0.0072168498348999998;
            weights[13] = 0.0072168498348999998;
            weights[14] = 0.0072168498348999998;
            weights[15] = 0.0024617018012000002;
            weights[16] = 0.0024617018012000002;
            weights[17] = 0.0024617018012000002;
            weights[18] = 0.012332876606299999;
            weights[19] = 0.012332876606299999;
            weights[20] = 0.012332876606299999;
            weights[21] = 0.012332876606299999;
            weights[22] = 0.012332876606299999;
            weights[23] = 0.012332876606299999;
            weights[24] = 0.01928575539355;
            weights[25] = 0.01928575539355;
            weights[26] = 0.01928575539355;
            weights[27] = 0.01928575539355;
            weights[28] = 0.01928575539355;
            weights[29] = 0.01928575539355;
            weights[30] = 0.0072181540567499997;
            weights[31] = 0.0072181540567499997;
            weights[32] = 0.0072181540567499997;
            weights[33] = 0.0072181540567499997;
            weights[34] = 0.0072181540567499997;
            weights[35] = 0.0072181540567499997;
            weights[36] = 0.0025051144192499999;
            weights[37] = 0.0025051144192499999;
            weights[38] = 0.0025051144192499999;
            weights[39] = 0.0025051144192499999;
            weights[40] = 0.0025051144192499999;
            weights[41] = 0.0025051144192499999;

            break;

        case 15:

            coordinates.resize(48*3);
            weights.resize(48);

            coordinates[0] = 0.50697291685799994;
            coordinates[1] = 0.50697291685799994;
            coordinates[2] = 0;
            coordinates[3] = -0.013945833716499999;
            coordinates[4] = 0.50697291685799994;
            coordinates[5] = 0;
            coordinates[6] = 0.50697291685799994;
            coordinates[7] = -0.013945833716499999;
            coordinates[8] = 0;
            coordinates[9] = 0.431406354283;
            coordinates[10] = 0.431406354283;
            coordinates[11] = 0;
            coordinates[12] = 0.13718729143399999;
            coordinates[13] = 0.431406354283;
            coordinates[14] = 0;
            coordinates[15] = 0.431406354283;
            coordinates[16] = 0.13718729143399999;
            coordinates[17] = 0;
            coordinates[18] = 0.27769364484699999;
            coordinates[19] = 0.27769364484699999;
            coordinates[20] = 0;
            coordinates[21] = 0.44461271030600003;
            coordinates[22] = 0.27769364484699999;
            coordinates[23] = 0;
            coordinates[24] = 0.27769364484699999;
            coordinates[25] = 0.44461271030600003;
            coordinates[26] = 0;
            coordinates[27] = 0.126464891041;
            coordinates[28] = 0.126464891041;
            coordinates[29] = 0;
            coordinates[30] = 0.74707021791700001;
            coordinates[31] = 0.126464891041;
            coordinates[32] = 0;
            coordinates[33] = 0.126464891041;
            coordinates[34] = 0.74707021791700001;
            coordinates[35] = 0;
            coordinates[36] = 0.070808385974700003;
            coordinates[37] = 0.070808385974700003;
            coordinates[38] = 0;
            coordinates[39] = 0.85838322805099998;
            coordinates[40] = 0.070808385974700003;
            coordinates[41] = 0;
            coordinates[42] = 0.070808385974700003;
            coordinates[43] = 0.85838322805099998;
            coordinates[44] = 0;
            coordinates[45] = 0.018965170241100001;
            coordinates[46] = 0.018965170241100001;
            coordinates[47] = 0;
            coordinates[48] = 0.96206965951800005;
            coordinates[49] = 0.018965170241100001;
            coordinates[50] = 0;
            coordinates[51] = 0.018965170241100001;
            coordinates[52] = 0.96206965951800005;
            coordinates[53] = 0;
            coordinates[54] = 0.60495446689300003;
            coordinates[55] = 0.26131137114000003;
            coordinates[56] = 0;
            coordinates[57] = 0.133734161967;
            coordinates[58] = 0.60495446689300003;
            coordinates[59] = 0;
            coordinates[60] = 0.26131137114000003;
            coordinates[61] = 0.133734161967;
            coordinates[62] = 0;
            coordinates[63] = 0.133734161967;
            coordinates[64] = 0.26131137114000003;
            coordinates[65] = 0;
            coordinates[66] = 0.26131137114000003;
            coordinates[67] = 0.60495446689300003;
            coordinates[68] = 0;
            coordinates[69] = 0.60495446689300003;
            coordinates[70] = 0.133734161967;
            coordinates[71] = 0;
            coordinates[72] = 0.57558655551299998;
            coordinates[73] = 0.38804676709000002;
            coordinates[74] = 0;
            coordinates[75] = 0.036366677396899999;
            coordinates[76] = 0.57558655551299998;
            coordinates[77] = 0;
            coordinates[78] = 0.38804676709000002;
            coordinates[79] = 0.036366677396899999;
            coordinates[80] = 0;
            coordinates[81] = 0.036366677396899999;
            coordinates[82] = 0.38804676709000002;
            coordinates[83] = 0;
            coordinates[84] = 0.38804676709000002;
            coordinates[85] = 0.57558655551299998;
            coordinates[86] = 0;
            coordinates[87] = 0.57558655551299998;
            coordinates[88] = 0.036366677396899999;
            coordinates[89] = 0;
            coordinates[90] = 0.72446266307700002;
            coordinates[91] = 0.28571222005000002;
            coordinates[92] = 0;
            coordinates[93] = -0.0101748831266;
            coordinates[94] = 0.72446266307700002;
            coordinates[95] = 0;
            coordinates[96] = 0.28571222005000002;
            coordinates[97] = -0.0101748831266;
            coordinates[98] = 0;
            coordinates[99] = -0.0101748831266;
            coordinates[100] = 0.28571222005000002;
            coordinates[101] = 0;
            coordinates[102] = 0.28571222005000002;
            coordinates[103] = 0.72446266307700002;
            coordinates[104] = 0;
            coordinates[105] = 0.72446266307700002;
            coordinates[106] = -0.0101748831266;
            coordinates[107] = 0;
            coordinates[108] = 0.74755646605199999;
            coordinates[109] = 0.21559966407200001;
            coordinates[110] = 0;
            coordinates[111] = 0.0368438698759;
            coordinates[112] = 0.74755646605199999;
            coordinates[113] = 0;
            coordinates[114] = 0.21559966407200001;
            coordinates[115] = 0.0368438698759;
            coordinates[116] = 0;
            coordinates[117] = 0.0368438698759;
            coordinates[118] = 0.21559966407200001;
            coordinates[119] = 0;
            coordinates[120] = 0.21559966407200001;
            coordinates[121] = 0.74755646605199999;
            coordinates[122] = 0;
            coordinates[123] = 0.74755646605199999;
            coordinates[124] = 0.0368438698759;
            coordinates[125] = 0;
            coordinates[126] = 0.88396457409200002;
            coordinates[127] = 0.10357561657600001;
            coordinates[128] = 0;
            coordinates[129] = 0.0124598093312;
            coordinates[130] = 0.88396457409200002;
            coordinates[131] = 0;
            coordinates[132] = 0.10357561657600001;
            coordinates[133] = 0.0124598093312;
            coordinates[134] = 0;
            coordinates[135] = 0.0124598093312;
            coordinates[136] = 0.10357561657600001;
            coordinates[137] = 0;
            coordinates[138] = 0.10357561657600001;
            coordinates[139] = 0.88396457409200002;
            coordinates[140] = 0;
            coordinates[141] = 0.88396457409200002;
            coordinates[142] = 0.0124598093312;
            coordinates[143] = 0;

            weights[0] = 0.00095843782142499999;
            weights[1] = 0.00095843782142499999;
            weights[2] = 0.00095843782142499999;
            weights[3] = 0.02212451363555;
            weights[4] = 0.02212451363555;
            weights[5] = 0.02212451363555;
            weights[6] = 0.02559327435945;
            weights[7] = 0.02559327435945;
            weights[8] = 0.02559327435945;
            weights[9] = 0.01184386793535;
            weights[10] = 0.01184386793535;
            weights[11] = 0.01184386793535;
            weights[12] = 0.006644887845;
            weights[13] = 0.006644887845;
            weights[14] = 0.006644887845;
            weights[15] = 0.0023744583040949999;
            weights[16] = 0.0023744583040949999;
            weights[17] = 0.0023744583040949999;
            weights[18] = 0.0192750362998;
            weights[19] = 0.0192750362998;
            weights[20] = 0.0192750362998;
            weights[21] = 0.0192750362998;
            weights[22] = 0.0192750362998;
            weights[23] = 0.0192750362998;
            weights[24] = 0.0136079071603;
            weights[25] = 0.0136079071603;
            weights[26] = 0.0136079071603;
            weights[27] = 0.0136079071603;
            weights[28] = 0.0136079071603;
            weights[29] = 0.0136079071603;
            weights[30] = 0.0010910386833999999;
            weights[31] = 0.0010910386833999999;
            weights[32] = 0.0010910386833999999;
            weights[33] = 0.0010910386833999999;
            weights[34] = 0.0010910386833999999;
            weights[35] = 0.0010910386833999999;
            weights[36] = 0.010752659923849999;
            weights[37] = 0.010752659923849999;
            weights[38] = 0.010752659923849999;
            weights[39] = 0.010752659923849999;
            weights[40] = 0.010752659923849999;
            weights[41] = 0.010752659923849999;
            weights[42] = 0.003836971315525;
            weights[43] = 0.003836971315525;
            weights[44] = 0.003836971315525;
            weights[45] = 0.003836971315525;
            weights[46] = 0.003836971315525;
            weights[47] = 0.003836971315525;

            break;

        case 16:

            coordinates.resize(52*3);
            weights.resize(52);

            coordinates[0] = 0.33333333333330001;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.49738054194800002;
            coordinates[4] = 0.49738054194800002;
            coordinates[5] = 0;
            coordinates[6] = 0.0052389161031200001;
            coordinates[7] = 0.49738054194800002;
            coordinates[8] = 0;
            coordinates[9] = 0.49738054194800002;
            coordinates[10] = 0.0052389161031200001;
            coordinates[11] = 0;
            coordinates[12] = 0.41346943854899998;
            coordinates[13] = 0.41346943854899998;
            coordinates[14] = 0;
            coordinates[15] = 0.17306112290100001;
            coordinates[16] = 0.41346943854899998;
            coordinates[17] = 0;
            coordinates[18] = 0.41346943854899998;
            coordinates[19] = 0.17306112290100001;
            coordinates[20] = 0;
            coordinates[21] = 0.47045859906699999;
            coordinates[22] = 0.47045859906699999;
            coordinates[23] = 0;
            coordinates[24] = 0.059082801865999998;
            coordinates[25] = 0.47045859906699999;
            coordinates[26] = 0;
            coordinates[27] = 0.47045859906699999;
            coordinates[28] = 0.059082801865999998;
            coordinates[29] = 0;
            coordinates[30] = 0.24055374997000001;
            coordinates[31] = 0.24055374997000001;
            coordinates[32] = 0;
            coordinates[33] = 0.51889250006099996;
            coordinates[34] = 0.24055374997000001;
            coordinates[35] = 0;
            coordinates[36] = 0.24055374997000001;
            coordinates[37] = 0.51889250006099996;
            coordinates[38] = 0;
            coordinates[39] = 0.14796579422299999;
            coordinates[40] = 0.14796579422299999;
            coordinates[41] = 0;
            coordinates[42] = 0.704068411555;
            coordinates[43] = 0.14796579422299999;
            coordinates[44] = 0;
            coordinates[45] = 0.14796579422299999;
            coordinates[46] = 0.704068411555;
            coordinates[47] = 0;
            coordinates[48] = 0.075465187657500002;
            coordinates[49] = 0.075465187657500002;
            coordinates[50] = 0;
            coordinates[51] = 0.84906962468500002;
            coordinates[52] = 0.075465187657500002;
            coordinates[53] = 0;
            coordinates[54] = 0.075465187657500002;
            coordinates[55] = 0.84906962468500002;
            coordinates[56] = 0;
            coordinates[57] = 0.016596402622999998;
            coordinates[58] = 0.016596402622999998;
            coordinates[59] = 0;
            coordinates[60] = 0.96680719475400001;
            coordinates[61] = 0.016596402622999998;
            coordinates[62] = 0;
            coordinates[63] = 0.016596402622999998;
            coordinates[64] = 0.96680719475400001;
            coordinates[65] = 0;
            coordinates[66] = 0.59986871117499996;
            coordinates[67] = 0.29655559658000002;
            coordinates[68] = 0;
            coordinates[69] = 0.103575692245;
            coordinates[70] = 0.59986871117499996;
            coordinates[71] = 0;
            coordinates[72] = 0.29655559658000002;
            coordinates[73] = 0.103575692245;
            coordinates[74] = 0;
            coordinates[75] = 0.103575692245;
            coordinates[76] = 0.29655559658000002;
            coordinates[77] = 0;
            coordinates[78] = 0.29655559658000002;
            coordinates[79] = 0.59986871117499996;
            coordinates[80] = 0;
            coordinates[81] = 0.59986871117499996;
            coordinates[82] = 0.103575692245;
            coordinates[83] = 0;
            coordinates[84] = 0.64219352494199999;
            coordinates[85] = 0.33772306340300001;
            coordinates[86] = 0;
            coordinates[87] = 0.020083411655400001;
            coordinates[88] = 0.64219352494199999;
            coordinates[89] = 0;
            coordinates[90] = 0.33772306340300001;
            coordinates[91] = 0.020083411655400001;
            coordinates[92] = 0;
            coordinates[93] = 0.020083411655400001;
            coordinates[94] = 0.33772306340300001;
            coordinates[95] = 0;
            coordinates[96] = 0.33772306340300001;
            coordinates[97] = 0.64219352494199999;
            coordinates[98] = 0;
            coordinates[99] = 0.64219352494199999;
            coordinates[100] = 0.020083411655400001;
            coordinates[101] = 0;
            coordinates[102] = 0.79959272097099998;
            coordinates[103] = 0.20474828164299999;
            coordinates[104] = 0;
            coordinates[105] = -0.0043410026141400002;
            coordinates[106] = 0.79959272097099998;
            coordinates[107] = 0;
            coordinates[108] = 0.20474828164299999;
            coordinates[109] = -0.0043410026141400002;
            coordinates[110] = 0;
            coordinates[111] = -0.0043410026141400002;
            coordinates[112] = 0.20474828164299999;
            coordinates[113] = 0;
            coordinates[114] = 0.20474828164299999;
            coordinates[115] = 0.79959272097099998;
            coordinates[116] = 0;
            coordinates[117] = 0.79959272097099998;
            coordinates[118] = -0.0043410026141400002;
            coordinates[119] = 0;
            coordinates[120] = 0.76869972140099996;
            coordinates[121] = 0.18935849213100001;
            coordinates[122] = 0;
            coordinates[123] = 0.041941786468000002;
            coordinates[124] = 0.76869972140099996;
            coordinates[125] = 0;
            coordinates[126] = 0.18935849213100001;
            coordinates[127] = 0.041941786468000002;
            coordinates[128] = 0;
            coordinates[129] = 0.041941786468000002;
            coordinates[130] = 0.18935849213100001;
            coordinates[131] = 0;
            coordinates[132] = 0.18935849213100001;
            coordinates[133] = 0.76869972140099996;
            coordinates[134] = 0;
            coordinates[135] = 0.76869972140099996;
            coordinates[136] = 0.041941786468000002;
            coordinates[137] = 0;
            coordinates[138] = 0.90039906408699999;
            coordinates[139] = 0.085283615682700001;
            coordinates[140] = 0;
            coordinates[141] = 0.0143173202307;
            coordinates[142] = 0.90039906408699999;
            coordinates[143] = 0;
            coordinates[144] = 0.085283615682700001;
            coordinates[145] = 0.0143173202307;
            coordinates[146] = 0;
            coordinates[147] = 0.0143173202307;
            coordinates[148] = 0.085283615682700001;
            coordinates[149] = 0;
            coordinates[150] = 0.085283615682700001;
            coordinates[151] = 0.90039906408699999;
            coordinates[152] = 0;
            coordinates[153] = 0.90039906408699999;
            coordinates[154] = 0.0143173202307;
            coordinates[155] = 0;

            weights[0] = 0.023437848713799999;
            weights[1] = 0.0032029392892900001;
            weights[2] = 0.0032029392892900001;
            weights[3] = 0.0032029392892900001;
            weights[4] = 0.0208551483697;
            weights[5] = 0.0208551483697;
            weights[6] = 0.0208551483697;
            weights[7] = 0.01344574212505;
            weights[8] = 0.01344574212505;
            weights[9] = 0.01344574212505;
            weights[10] = 0.021066261380799998;
            weights[11] = 0.021066261380799998;
            weights[12] = 0.021066261380799998;
            weights[13] = 0.015000133421400001;
            weights[14] = 0.015000133421400001;
            weights[15] = 0.015000133421400001;
            weights[16] = 0.0071000494624999999;
            weights[17] = 0.0071000494624999999;
            weights[18] = 0.0071000494624999999;
            weights[19] = 0.0017912311756349999;
            weights[20] = 0.0017912311756349999;
            weights[21] = 0.0017912311756349999;
            weights[22] = 0.016386573730299999;
            weights[23] = 0.016386573730299999;
            weights[24] = 0.016386573730299999;
            weights[25] = 0.016386573730299999;
            weights[26] = 0.016386573730299999;
            weights[27] = 0.016386573730299999;
            weights[28] = 0.0076491531241999998;
            weights[29] = 0.0076491531241999998;
            weights[30] = 0.0076491531241999998;
            weights[31] = 0.0076491531241999998;
            weights[32] = 0.0076491531241999998;
            weights[33] = 0.0076491531241999998;
            weights[34] = 0.00119312209642;
            weights[35] = 0.00119312209642;
            weights[36] = 0.00119312209642;
            weights[37] = 0.00119312209642;
            weights[38] = 0.00119312209642;
            weights[39] = 0.00119312209642;
            weights[40] = 0.0095423963779499993;
            weights[41] = 0.0095423963779499993;
            weights[42] = 0.0095423963779499993;
            weights[43] = 0.0095423963779499993;
            weights[44] = 0.0095423963779499993;
            weights[45] = 0.0095423963779499993;
            weights[46] = 0.0034250272732700001;
            weights[47] = 0.0034250272732700001;
            weights[48] = 0.0034250272732700001;
            weights[49] = 0.0034250272732700001;
            weights[50] = 0.0034250272732700001;
            weights[51] = 0.0034250272732700001;

            break;

        case 17:

            coordinates.resize(61*3);
            weights.resize(61);

            coordinates[0] = 0.33333333333330001;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.497170540557;
            coordinates[4] = 0.497170540557;
            coordinates[5] = 0;
            coordinates[6] = 0.00565891888645;
            coordinates[7] = 0.497170540557;
            coordinates[8] = 0;
            coordinates[9] = 0.497170540557;
            coordinates[10] = 0.00565891888645;
            coordinates[11] = 0;
            coordinates[12] = 0.48217632262499999;
            coordinates[13] = 0.48217632262499999;
            coordinates[14] = 0;
            coordinates[15] = 0.035647354750799998;
            coordinates[16] = 0.48217632262499999;
            coordinates[17] = 0;
            coordinates[18] = 0.48217632262499999;
            coordinates[19] = 0.035647354750799998;
            coordinates[20] = 0;
            coordinates[21] = 0.450239969021;
            coordinates[22] = 0.450239969021;
            coordinates[23] = 0;
            coordinates[24] = 0.099520061958400005;
            coordinates[25] = 0.450239969021;
            coordinates[26] = 0;
            coordinates[27] = 0.450239969021;
            coordinates[28] = 0.099520061958400005;
            coordinates[29] = 0;
            coordinates[30] = 0.40026623937700001;
            coordinates[31] = 0.40026623937700001;
            coordinates[32] = 0;
            coordinates[33] = 0.199467521245;
            coordinates[34] = 0.40026623937700001;
            coordinates[35] = 0;
            coordinates[36] = 0.40026623937700001;
            coordinates[37] = 0.199467521245;
            coordinates[38] = 0;
            coordinates[39] = 0.252141267971;
            coordinates[40] = 0.252141267971;
            coordinates[41] = 0;
            coordinates[42] = 0.49571746405799999;
            coordinates[43] = 0.252141267971;
            coordinates[44] = 0;
            coordinates[45] = 0.252141267971;
            coordinates[46] = 0.49571746405799999;
            coordinates[47] = 0;
            coordinates[48] = 0.16204700465800001;
            coordinates[49] = 0.16204700465800001;
            coordinates[50] = 0;
            coordinates[51] = 0.67590599068299995;
            coordinates[52] = 0.16204700465800001;
            coordinates[53] = 0;
            coordinates[54] = 0.16204700465800001;
            coordinates[55] = 0.67590599068299995;
            coordinates[56] = 0;
            coordinates[57] = 0.075875882260699995;
            coordinates[58] = 0.075875882260699995;
            coordinates[59] = 0;
            coordinates[60] = 0.84824823547899997;
            coordinates[61] = 0.075875882260699995;
            coordinates[62] = 0;
            coordinates[63] = 0.075875882260699995;
            coordinates[64] = 0.84824823547899997;
            coordinates[65] = 0;
            coordinates[66] = 0.015654726967800001;
            coordinates[67] = 0.015654726967800001;
            coordinates[68] = 0;
            coordinates[69] = 0.96869054606399996;
            coordinates[70] = 0.015654726967800001;
            coordinates[71] = 0;
            coordinates[72] = 0.015654726967800001;
            coordinates[73] = 0.96869054606399996;
            coordinates[74] = 0;
            coordinates[75] = 0.655493203809;
            coordinates[76] = 0.33431986736399999;
            coordinates[77] = 0;
            coordinates[78] = 0.010186928826899999;
            coordinates[79] = 0.655493203809;
            coordinates[80] = 0;
            coordinates[81] = 0.33431986736399999;
            coordinates[82] = 0.010186928826899999;
            coordinates[83] = 0;
            coordinates[84] = 0.010186928826899999;
            coordinates[85] = 0.33431986736399999;
            coordinates[86] = 0;
            coordinates[87] = 0.33431986736399999;
            coordinates[88] = 0.655493203809;
            coordinates[89] = 0;
            coordinates[90] = 0.655493203809;
            coordinates[91] = 0.010186928826899999;
            coordinates[92] = 0;
            coordinates[93] = 0.57233759053199995;
            coordinates[94] = 0.292221537797;
            coordinates[95] = 0;
            coordinates[96] = 0.135440871671;
            coordinates[97] = 0.57233759053199995;
            coordinates[98] = 0;
            coordinates[99] = 0.292221537797;
            coordinates[100] = 0.135440871671;
            coordinates[101] = 0;
            coordinates[102] = 0.135440871671;
            coordinates[103] = 0.292221537797;
            coordinates[104] = 0;
            coordinates[105] = 0.292221537797;
            coordinates[106] = 0.57233759053199995;
            coordinates[107] = 0;
            coordinates[108] = 0.57233759053199995;
            coordinates[109] = 0.135440871671;
            coordinates[110] = 0;
            coordinates[111] = 0.62600119028599999;
            coordinates[112] = 0.319574885423;
            coordinates[113] = 0;
            coordinates[114] = 0.054423924290600001;
            coordinates[115] = 0.62600119028599999;
            coordinates[116] = 0;
            coordinates[117] = 0.319574885423;
            coordinates[118] = 0.054423924290600001;
            coordinates[119] = 0;
            coordinates[120] = 0.054423924290600001;
            coordinates[121] = 0.319574885423;
            coordinates[122] = 0;
            coordinates[123] = 0.319574885423;
            coordinates[124] = 0.62600119028599999;
            coordinates[125] = 0;
            coordinates[126] = 0.62600119028599999;
            coordinates[127] = 0.054423924290600001;
            coordinates[128] = 0;
            coordinates[129] = 0.79642721497400004;
            coordinates[130] = 0.190704224192;
            coordinates[131] = 0;
            coordinates[132] = 0.012868560833599999;
            coordinates[133] = 0.79642721497400004;
            coordinates[134] = 0;
            coordinates[135] = 0.190704224192;
            coordinates[136] = 0.012868560833599999;
            coordinates[137] = 0;
            coordinates[138] = 0.012868560833599999;
            coordinates[139] = 0.190704224192;
            coordinates[140] = 0;
            coordinates[141] = 0.190704224192;
            coordinates[142] = 0.79642721497400004;
            coordinates[143] = 0;
            coordinates[144] = 0.79642721497400004;
            coordinates[145] = 0.012868560833599999;
            coordinates[146] = 0;
            coordinates[147] = 0.75235100593799997;
            coordinates[148] = 0.180483211649;
            coordinates[149] = 0;
            coordinates[150] = 0.067165782413500005;
            coordinates[151] = 0.75235100593799997;
            coordinates[152] = 0;
            coordinates[153] = 0.180483211649;
            coordinates[154] = 0.067165782413500005;
            coordinates[155] = 0;
            coordinates[156] = 0.067165782413500005;
            coordinates[157] = 0.180483211649;
            coordinates[158] = 0;
            coordinates[159] = 0.180483211649;
            coordinates[160] = 0.75235100593799997;
            coordinates[161] = 0;
            coordinates[162] = 0.75235100593799997;
            coordinates[163] = 0.067165782413500005;
            coordinates[164] = 0;
            coordinates[165] = 0.90462550409599995;
            coordinates[166] = 0.080711313679599994;
            coordinates[167] = 0;
            coordinates[168] = 0.0146631822248;
            coordinates[169] = 0.90462550409599995;
            coordinates[170] = 0;
            coordinates[171] = 0.080711313679599994;
            coordinates[172] = 0.0146631822248;
            coordinates[173] = 0;
            coordinates[174] = 0.0146631822248;
            coordinates[175] = 0.080711313679599994;
            coordinates[176] = 0;
            coordinates[177] = 0.080711313679599994;
            coordinates[178] = 0.90462550409599995;
            coordinates[179] = 0;
            coordinates[180] = 0.90462550409599995;
            coordinates[181] = 0.0146631822248;
            coordinates[182] = 0;

            weights[0] = 0.016718599645400001;
            weights[1] = 0.0025467077202549998;
            weights[2] = 0.0025467077202549998;
            weights[3] = 0.0025467077202549998;
            weights[4] = 0.0073354322638000003;
            weights[5] = 0.0073354322638000003;
            weights[6] = 0.0073354322638000003;
            weights[7] = 0.01217543917685;
            weights[8] = 0.01217543917685;
            weights[9] = 0.01217543917685;
            weights[10] = 0.015553775434500001;
            weights[11] = 0.015553775434500001;
            weights[12] = 0.015553775434500001;
            weights[13] = 0.015628555609300002;
            weights[14] = 0.015628555609300002;
            weights[15] = 0.015628555609300002;
            weights[16] = 0.01240782716985;
            weights[17] = 0.01240782716985;
            weights[18] = 0.01240782716985;
            weights[19] = 0.0070280365353000002;
            weights[20] = 0.0070280365353000002;
            weights[21] = 0.0070280365353000002;
            weights[22] = 0.00159733808689;
            weights[23] = 0.00159733808689;
            weights[24] = 0.00159733808689;
            weights[25] = 0.0040598276594949996;
            weights[26] = 0.0040598276594949996;
            weights[27] = 0.0040598276594949996;
            weights[28] = 0.0040598276594949996;
            weights[29] = 0.0040598276594949996;
            weights[30] = 0.0040598276594949996;
            weights[31] = 0.013402871141599999;
            weights[32] = 0.013402871141599999;
            weights[33] = 0.013402871141599999;
            weights[34] = 0.013402871141599999;
            weights[35] = 0.013402871141599999;
            weights[36] = 0.013402871141599999;
            weights[37] = 0.0092299966054;
            weights[38] = 0.0092299966054;
            weights[39] = 0.0092299966054;
            weights[40] = 0.0092299966054;
            weights[41] = 0.0092299966054;
            weights[42] = 0.0092299966054;
            weights[43] = 0.0042384342671650003;
            weights[44] = 0.0042384342671650003;
            weights[45] = 0.0042384342671650003;
            weights[46] = 0.0042384342671650003;
            weights[47] = 0.0042384342671650003;
            weights[48] = 0.0042384342671650003;
            weights[49] = 0.0091463983850000007;
            weights[50] = 0.0091463983850000007;
            weights[51] = 0.0091463983850000007;
            weights[52] = 0.0091463983850000007;
            weights[53] = 0.0091463983850000007;
            weights[54] = 0.0091463983850000007;
            weights[55] = 0.0033328160020849999;
            weights[56] = 0.0033328160020849999;
            weights[57] = 0.0033328160020849999;
            weights[58] = 0.0033328160020849999;
            weights[59] = 0.0033328160020849999;
            weights[60] = 0.0033328160020849999;

            break;

        case 18:

            coordinates.resize(70*3);
            weights.resize(70);

            coordinates[0] = 0.33333333333330001;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.493344808631;
            coordinates[4] = 0.493344808631;
            coordinates[5] = 0;
            coordinates[6] = 0.0133103827382;
            coordinates[7] = 0.493344808631;
            coordinates[8] = 0;
            coordinates[9] = 0.493344808631;
            coordinates[10] = 0.0133103827382;
            coordinates[11] = 0;
            coordinates[12] = 0.46921059424200001;
            coordinates[13] = 0.46921059424200001;
            coordinates[14] = 0;
            coordinates[15] = 0.0615788115161;
            coordinates[16] = 0.46921059424200001;
            coordinates[17] = 0;
            coordinates[18] = 0.46921059424200001;
            coordinates[19] = 0.0615788115161;
            coordinates[20] = 0;
            coordinates[21] = 0.43628139588699999;
            coordinates[22] = 0.43628139588699999;
            coordinates[23] = 0;
            coordinates[24] = 0.12743720822599999;
            coordinates[25] = 0.43628139588699999;
            coordinates[26] = 0;
            coordinates[27] = 0.43628139588699999;
            coordinates[28] = 0.12743720822599999;
            coordinates[29] = 0;
            coordinates[30] = 0.39484617067299999;
            coordinates[31] = 0.39484617067299999;
            coordinates[32] = 0;
            coordinates[33] = 0.210307658653;
            coordinates[34] = 0.39484617067299999;
            coordinates[35] = 0;
            coordinates[36] = 0.39484617067299999;
            coordinates[37] = 0.210307658653;
            coordinates[38] = 0;
            coordinates[39] = 0.24979456880299999;
            coordinates[40] = 0.24979456880299999;
            coordinates[41] = 0;
            coordinates[42] = 0.50041086239400001;
            coordinates[43] = 0.24979456880299999;
            coordinates[44] = 0;
            coordinates[45] = 0.24979456880299999;
            coordinates[46] = 0.50041086239400001;
            coordinates[47] = 0;
            coordinates[48] = 0.161432193744;
            coordinates[49] = 0.161432193744;
            coordinates[50] = 0;
            coordinates[51] = 0.67713561251200005;
            coordinates[52] = 0.161432193744;
            coordinates[53] = 0;
            coordinates[54] = 0.161432193744;
            coordinates[55] = 0.67713561251200005;
            coordinates[56] = 0;
            coordinates[57] = 0.076598227485400003;
            coordinates[58] = 0.076598227485400003;
            coordinates[59] = 0;
            coordinates[60] = 0.84680354502900002;
            coordinates[61] = 0.076598227485400003;
            coordinates[62] = 0;
            coordinates[63] = 0.076598227485400003;
            coordinates[64] = 0.84680354502900002;
            coordinates[65] = 0;
            coordinates[66] = 0.024252439353500001;
            coordinates[67] = 0.024252439353500001;
            coordinates[68] = 0;
            coordinates[69] = 0.95149512129299996;
            coordinates[70] = 0.024252439353500001;
            coordinates[71] = 0;
            coordinates[72] = 0.024252439353500001;
            coordinates[73] = 0.95149512129299996;
            coordinates[74] = 0;
            coordinates[75] = 0.043146367216999999;
            coordinates[76] = 0.043146367216999999;
            coordinates[77] = 0;
            coordinates[78] = 0.91370726556600002;
            coordinates[79] = 0.043146367216999999;
            coordinates[80] = 0;
            coordinates[81] = 0.043146367216999999;
            coordinates[82] = 0.91370726556600002;
            coordinates[83] = 0;
            coordinates[84] = 0.63265796885699999;
            coordinates[85] = 0.358911494941;
            coordinates[86] = 0;
            coordinates[87] = 0.0084305362024199998;
            coordinates[88] = 0.63265796885699999;
            coordinates[89] = 0;
            coordinates[90] = 0.358911494941;
            coordinates[91] = 0.0084305362024199998;
            coordinates[92] = 0;
            coordinates[93] = 0.0084305362024199998;
            coordinates[94] = 0.358911494941;
            coordinates[95] = 0;
            coordinates[96] = 0.358911494941;
            coordinates[97] = 0.63265796885699999;
            coordinates[98] = 0;
            coordinates[99] = 0.63265796885699999;
            coordinates[100] = 0.0084305362024199998;
            coordinates[101] = 0;
            coordinates[102] = 0.57441097151099996;
            coordinates[103] = 0.29440247675199999;
            coordinates[104] = 0;
            coordinates[105] = 0.131186551737;
            coordinates[106] = 0.57441097151099996;
            coordinates[107] = 0;
            coordinates[108] = 0.29440247675199999;
            coordinates[109] = 0.131186551737;
            coordinates[110] = 0;
            coordinates[111] = 0.131186551737;
            coordinates[112] = 0.29440247675199999;
            coordinates[113] = 0;
            coordinates[114] = 0.29440247675199999;
            coordinates[115] = 0.57441097151099996;
            coordinates[116] = 0;
            coordinates[117] = 0.57441097151099996;
            coordinates[118] = 0.131186551737;
            coordinates[119] = 0;
            coordinates[120] = 0.624779046793;
            coordinates[121] = 0.325017801642;
            coordinates[122] = 0;
            coordinates[123] = 0.050203151565700002;
            coordinates[124] = 0.624779046793;
            coordinates[125] = 0;
            coordinates[126] = 0.325017801642;
            coordinates[127] = 0.050203151565700002;
            coordinates[128] = 0;
            coordinates[129] = 0.050203151565700002;
            coordinates[130] = 0.325017801642;
            coordinates[131] = 0;
            coordinates[132] = 0.325017801642;
            coordinates[133] = 0.624779046793;
            coordinates[134] = 0;
            coordinates[135] = 0.624779046793;
            coordinates[136] = 0.050203151565700002;
            coordinates[137] = 0;
            coordinates[138] = 0.74893317652299995;
            coordinates[139] = 0.184737559666;
            coordinates[140] = 0;
            coordinates[141] = 0.066329263810899999;
            coordinates[142] = 0.74893317652299995;
            coordinates[143] = 0;
            coordinates[144] = 0.184737559666;
            coordinates[145] = 0.066329263810899999;
            coordinates[146] = 0;
            coordinates[147] = 0.066329263810899999;
            coordinates[148] = 0.184737559666;
            coordinates[149] = 0;
            coordinates[150] = 0.184737559666;
            coordinates[151] = 0.74893317652299995;
            coordinates[152] = 0;
            coordinates[153] = 0.74893317652299995;
            coordinates[154] = 0.066329263810899999;
            coordinates[155] = 0;
            coordinates[156] = 0.76920700541999998;
            coordinates[157] = 0.218796800013;
            coordinates[158] = 0;
            coordinates[159] = 0.0119961945662;
            coordinates[160] = 0.76920700541999998;
            coordinates[161] = 0;
            coordinates[162] = 0.218796800013;
            coordinates[163] = 0.0119961945662;
            coordinates[164] = 0;
            coordinates[165] = 0.0119961945662;
            coordinates[166] = 0.218796800013;
            coordinates[167] = 0;
            coordinates[168] = 0.218796800013;
            coordinates[169] = 0.76920700541999998;
            coordinates[170] = 0;
            coordinates[171] = 0.76920700541999998;
            coordinates[172] = 0.0119961945662;
            coordinates[173] = 0;
            coordinates[174] = 0.88396230227299999;
            coordinates[175] = 0.101179597136;
            coordinates[176] = 0;
            coordinates[177] = 0.014858100590099999;
            coordinates[178] = 0.88396230227299999;
            coordinates[179] = 0;
            coordinates[180] = 0.101179597136;
            coordinates[181] = 0.014858100590099999;
            coordinates[182] = 0;
            coordinates[183] = 0.014858100590099999;
            coordinates[184] = 0.101179597136;
            coordinates[185] = 0;
            coordinates[186] = 0.101179597136;
            coordinates[187] = 0.88396230227299999;
            coordinates[188] = 0;
            coordinates[189] = 0.88396230227299999;
            coordinates[190] = 0.014858100590099999;
            coordinates[191] = 0;
            coordinates[192] = 1.0143472600100001;
            coordinates[193] = 0.020874755282600001;
            coordinates[194] = 0;
            coordinates[195] = -0.035222015287899998;
            coordinates[196] = 1.0143472600100001;
            coordinates[197] = 0;
            coordinates[198] = 0.020874755282600001;
            coordinates[199] = -0.035222015287899998;
            coordinates[200] = 0;
            coordinates[201] = -0.035222015287899998;
            coordinates[202] = 0.020874755282600001;
            coordinates[203] = 0;
            coordinates[204] = 0.020874755282600001;
            coordinates[205] = 1.0143472600100001;
            coordinates[206] = 0;
            coordinates[207] = 1.0143472600100001;
            coordinates[208] = -0.035222015287899998;
            coordinates[209] = 0;

            weights[0] = 0.0154049699688;
            weights[1] = 0.0045362183396999997;
            weights[2] = 0.0045362183396999997;
            weights[3] = 0.0045362183396999997;
            weights[4] = 0.0093806584697999993;
            weights[5] = 0.0093806584697999993;
            weights[6] = 0.0093806584697999993;
            weights[7] = 0.0097205489927499993;
            weights[8] = 0.0097205489927499993;
            weights[9] = 0.0097205489927499993;
            weights[10] = 0.013876974305400001;
            weights[11] = 0.013876974305400001;
            weights[12] = 0.013876974305400001;
            weights[13] = 0.016128112675750001;
            weights[14] = 0.016128112675750001;
            weights[15] = 0.016128112675750001;
            weights[16] = 0.01253701630845;
            weights[17] = 0.01253701630845;
            weights[18] = 0.01253701630845;
            weights[19] = 0.0076359639858999996;
            weights[20] = 0.0076359639858999996;
            weights[21] = 0.0076359639858999996;
            weights[22] = 0.0033969610114800001;
            weights[23] = 0.0033969610114800001;
            weights[24] = 0.0033969610114800001;
            weights[25] = -0.00111154936496;
            weights[26] = -0.00111154936496;
            weights[27] = -0.00111154936496;
            weights[28] = 0.003165957038205;
            weights[29] = 0.003165957038205;
            weights[30] = 0.003165957038205;
            weights[31] = 0.003165957038205;
            weights[32] = 0.003165957038205;
            weights[33] = 0.003165957038205;
            weights[34] = 0.01362876902455;
            weights[35] = 0.01362876902455;
            weights[36] = 0.01362876902455;
            weights[37] = 0.01362876902455;
            weights[38] = 0.01362876902455;
            weights[39] = 0.01362876902455;
            weights[40] = 0.0088383928247499997;
            weights[41] = 0.0088383928247499997;
            weights[42] = 0.0088383928247499997;
            weights[43] = 0.0088383928247499997;
            weights[44] = 0.0088383928247499997;
            weights[45] = 0.0088383928247499997;
            weights[46] = 0.0091897423190500007;
            weights[47] = 0.0091897423190500007;
            weights[48] = 0.0091897423190500007;
            weights[49] = 0.0091897423190500007;
            weights[50] = 0.0091897423190500007;
            weights[51] = 0.0091897423190500007;
            weights[52] = 0.0040523664040949996;
            weights[53] = 0.0040523664040949996;
            weights[54] = 0.0040523664040949996;
            weights[55] = 0.0040523664040949996;
            weights[56] = 0.0040523664040949996;
            weights[57] = 0.0040523664040949996;
            weights[58] = 0.0038170645353649999;
            weights[59] = 0.0038170645353649999;
            weights[60] = 0.0038170645353649999;
            weights[61] = 0.0038170645353649999;
            weights[62] = 0.0038170645353649999;
            weights[63] = 0.0038170645353649999;
            weights[64] = 2.3093830397e-05;
            weights[65] = 2.3093830397e-05;
            weights[66] = 2.3093830397e-05;
            weights[67] = 2.3093830397e-05;
            weights[68] = 2.3093830397e-05;
            weights[69] = 2.3093830397e-05;

            break;

        case 19:

            coordinates.resize(73*3);
            weights.resize(73);

            coordinates[0] = 0.33333333333330001;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.48960998707300002;
            coordinates[4] = 0.48960998707300002;
            coordinates[5] = 0;
            coordinates[6] = 0.020780025854;
            coordinates[7] = 0.48960998707300002;
            coordinates[8] = 0;
            coordinates[9] = 0.48960998707300002;
            coordinates[10] = 0.020780025854;
            coordinates[11] = 0;
            coordinates[12] = 0.45453689269800002;
            coordinates[13] = 0.45453689269800002;
            coordinates[14] = 0;
            coordinates[15] = 0.090926214604200001;
            coordinates[16] = 0.45453689269800002;
            coordinates[17] = 0;
            coordinates[18] = 0.45453689269800002;
            coordinates[19] = 0.090926214604200001;
            coordinates[20] = 0;
            coordinates[21] = 0.40141668064899999;
            coordinates[22] = 0.40141668064899999;
            coordinates[23] = 0;
            coordinates[24] = 0.19716663870100001;
            coordinates[25] = 0.40141668064899999;
            coordinates[26] = 0;
            coordinates[27] = 0.40141668064899999;
            coordinates[28] = 0.19716663870100001;
            coordinates[29] = 0;
            coordinates[30] = 0.25555165440299998;
            coordinates[31] = 0.25555165440299998;
            coordinates[32] = 0;
            coordinates[33] = 0.48889669119399998;
            coordinates[34] = 0.25555165440299998;
            coordinates[35] = 0;
            coordinates[36] = 0.25555165440299998;
            coordinates[37] = 0.48889669119399998;
            coordinates[38] = 0;
            coordinates[39] = 0.17707794215200001;
            coordinates[40] = 0.17707794215200001;
            coordinates[41] = 0;
            coordinates[42] = 0.64584411569599998;
            coordinates[43] = 0.17707794215200001;
            coordinates[44] = 0;
            coordinates[45] = 0.17707794215200001;
            coordinates[46] = 0.64584411569599998;
            coordinates[47] = 0;
            coordinates[48] = 0.110061053228;
            coordinates[49] = 0.110061053228;
            coordinates[50] = 0;
            coordinates[51] = 0.77987789354399994;
            coordinates[52] = 0.110061053228;
            coordinates[53] = 0;
            coordinates[54] = 0.110061053228;
            coordinates[55] = 0.77987789354399994;
            coordinates[56] = 0;
            coordinates[57] = 0.055528624251800003;
            coordinates[58] = 0.055528624251800003;
            coordinates[59] = 0;
            coordinates[60] = 0.88894275149599999;
            coordinates[61] = 0.055528624251800003;
            coordinates[62] = 0;
            coordinates[63] = 0.055528624251800003;
            coordinates[64] = 0.88894275149599999;
            coordinates[65] = 0;
            coordinates[66] = 0.012621863777199999;
            coordinates[67] = 0.012621863777199999;
            coordinates[68] = 0;
            coordinates[69] = 0.97475627244600005;
            coordinates[70] = 0.012621863777199999;
            coordinates[71] = 0;
            coordinates[72] = 0.012621863777199999;
            coordinates[73] = 0.97475627244600005;
            coordinates[74] = 0;
            coordinates[75] = 0.60063379479500001;
            coordinates[76] = 0.39575478735699998;
            coordinates[77] = 0;
            coordinates[78] = 0.0036114178484099998;
            coordinates[79] = 0.60063379479500001;
            coordinates[80] = 0;
            coordinates[81] = 0.39575478735699998;
            coordinates[82] = 0.0036114178484099998;
            coordinates[83] = 0;
            coordinates[84] = 0.0036114178484099998;
            coordinates[85] = 0.39575478735699998;
            coordinates[86] = 0;
            coordinates[87] = 0.39575478735699998;
            coordinates[88] = 0.60063379479500001;
            coordinates[89] = 0;
            coordinates[90] = 0.60063379479500001;
            coordinates[91] = 0.0036114178484099998;
            coordinates[92] = 0;
            coordinates[93] = 0.55760326158899998;
            coordinates[94] = 0.30792998387999998;
            coordinates[95] = 0;
            coordinates[96] = 0.13446675453099999;
            coordinates[97] = 0.55760326158899998;
            coordinates[98] = 0;
            coordinates[99] = 0.30792998387999998;
            coordinates[100] = 0.13446675453099999;
            coordinates[101] = 0;
            coordinates[102] = 0.13446675453099999;
            coordinates[103] = 0.30792998387999998;
            coordinates[104] = 0;
            coordinates[105] = 0.30792998387999998;
            coordinates[106] = 0.55760326158899998;
            coordinates[107] = 0;
            coordinates[108] = 0.55760326158899998;
            coordinates[109] = 0.13446675453099999;
            coordinates[110] = 0;
            coordinates[111] = 0.72098702581700003;
            coordinates[112] = 0.26456694840700001;
            coordinates[113] = 0;
            coordinates[114] = 0.0144460257761;
            coordinates[115] = 0.72098702581700003;
            coordinates[116] = 0;
            coordinates[117] = 0.26456694840700001;
            coordinates[118] = 0.0144460257761;
            coordinates[119] = 0;
            coordinates[120] = 0.0144460257761;
            coordinates[121] = 0.26456694840700001;
            coordinates[122] = 0;
            coordinates[123] = 0.26456694840700001;
            coordinates[124] = 0.72098702581700003;
            coordinates[125] = 0;
            coordinates[126] = 0.72098702581700003;
            coordinates[127] = 0.0144460257761;
            coordinates[128] = 0;
            coordinates[129] = 0.59452706895600005;
            coordinates[130] = 0.35853935220599997;
            coordinates[131] = 0;
            coordinates[132] = 0.046933578838199999;
            coordinates[133] = 0.59452706895600005;
            coordinates[134] = 0;
            coordinates[135] = 0.35853935220599997;
            coordinates[136] = 0.046933578838199999;
            coordinates[137] = 0;
            coordinates[138] = 0.046933578838199999;
            coordinates[139] = 0.35853935220599997;
            coordinates[140] = 0;
            coordinates[141] = 0.35853935220599997;
            coordinates[142] = 0.59452706895600005;
            coordinates[143] = 0;
            coordinates[144] = 0.59452706895600005;
            coordinates[145] = 0.046933578838199999;
            coordinates[146] = 0;
            coordinates[147] = 0.83933147368100003;
            coordinates[148] = 0.157807405969;
            coordinates[149] = 0;
            coordinates[150] = 0.0028611203505700001;
            coordinates[151] = 0.83933147368100003;
            coordinates[152] = 0;
            coordinates[153] = 0.157807405969;
            coordinates[154] = 0.0028611203505700001;
            coordinates[155] = 0;
            coordinates[156] = 0.0028611203505700001;
            coordinates[157] = 0.157807405969;
            coordinates[158] = 0;
            coordinates[159] = 0.157807405969;
            coordinates[160] = 0.83933147368100003;
            coordinates[161] = 0;
            coordinates[162] = 0.83933147368100003;
            coordinates[163] = 0.0028611203505700001;
            coordinates[164] = 0;
            coordinates[165] = 0.70108797892600005;
            coordinates[166] = 0.075050596975899997;
            coordinates[167] = 0;
            coordinates[168] = 0.223861424098;
            coordinates[169] = 0.70108797892600005;
            coordinates[170] = 0;
            coordinates[171] = 0.075050596975899997;
            coordinates[172] = 0.223861424098;
            coordinates[173] = 0;
            coordinates[174] = 0.223861424098;
            coordinates[175] = 0.075050596975899997;
            coordinates[176] = 0;
            coordinates[177] = 0.075050596975899997;
            coordinates[178] = 0.70108797892600005;
            coordinates[179] = 0;
            coordinates[180] = 0.70108797892600005;
            coordinates[181] = 0.223861424098;
            coordinates[182] = 0;
            coordinates[183] = 0.82293132407000003;
            coordinates[184] = 0.14242160111300001;
            coordinates[185] = 0;
            coordinates[186] = 0.034647074816800003;
            coordinates[187] = 0.82293132407000003;
            coordinates[188] = 0;
            coordinates[189] = 0.14242160111300001;
            coordinates[190] = 0.034647074816800003;
            coordinates[191] = 0;
            coordinates[192] = 0.034647074816800003;
            coordinates[193] = 0.14242160111300001;
            coordinates[194] = 0;
            coordinates[195] = 0.14242160111300001;
            coordinates[196] = 0.82293132407000003;
            coordinates[197] = 0;
            coordinates[198] = 0.82293132407000003;
            coordinates[199] = 0.034647074816800003;
            coordinates[200] = 0;
            coordinates[201] = 0.92434425262099995;
            coordinates[202] = 0.065494628082900005;
            coordinates[203] = 0;
            coordinates[204] = 0.0101611192963;
            coordinates[205] = 0.92434425262099995;
            coordinates[206] = 0;
            coordinates[207] = 0.065494628082900005;
            coordinates[208] = 0.0101611192963;
            coordinates[209] = 0;
            coordinates[210] = 0.0101611192963;
            coordinates[211] = 0.065494628082900005;
            coordinates[212] = 0;
            coordinates[213] = 0.065494628082900005;
            coordinates[214] = 0.92434425262099995;
            coordinates[215] = 0;
            coordinates[216] = 0.92434425262099995;
            coordinates[217] = 0.0101611192963;
            coordinates[218] = 0;

            weights[0] = 0.01645316569445;
            weights[1] = 0.00516536594565;
            weights[2] = 0.00516536594565;
            weights[3] = 0.00516536594565;
            weights[4] = 0.0111936236315;
            weights[5] = 0.0111936236315;
            weights[6] = 0.0111936236315;
            weights[7] = 0.015133062934750001;
            weights[8] = 0.015133062934750001;
            weights[9] = 0.015133062934750001;
            weights[10] = 0.015245483901100001;
            weights[11] = 0.015245483901100001;
            weights[12] = 0.015245483901100001;
            weights[13] = 0.0120796063708;
            weights[14] = 0.0120796063708;
            weights[15] = 0.0120796063708;
            weights[16] = 0.0080254017933999999;
            weights[17] = 0.0080254017933999999;
            weights[18] = 0.0080254017933999999;
            weights[19] = 0.0040422901308899998;
            weights[20] = 0.0040422901308899998;
            weights[21] = 0.0040422901308899998;
            weights[22] = 0.00103968101374;
            weights[23] = 0.00103968101374;
            weights[24] = 0.00103968101374;
            weights[25] = 0.00194243845249;
            weights[26] = 0.00194243845249;
            weights[27] = 0.00194243845249;
            weights[28] = 0.00194243845249;
            weights[29] = 0.00194243845249;
            weights[30] = 0.00194243845249;
            weights[31] = 0.012787080306000001;
            weights[32] = 0.012787080306000001;
            weights[33] = 0.012787080306000001;
            weights[34] = 0.012787080306000001;
            weights[35] = 0.012787080306000001;
            weights[36] = 0.012787080306000001;
            weights[37] = 0.0044404517866699997;
            weights[38] = 0.0044404517866699997;
            weights[39] = 0.0044404517866699997;
            weights[40] = 0.0044404517866699997;
            weights[41] = 0.0044404517866699997;
            weights[42] = 0.0044404517866699997;
            weights[43] = 0.0080622733808500009;
            weights[44] = 0.0080622733808500009;
            weights[45] = 0.0080622733808500009;
            weights[46] = 0.0080622733808500009;
            weights[47] = 0.0080622733808500009;
            weights[48] = 0.0080622733808500009;
            weights[49] = 0.0012459709087449999;
            weights[50] = 0.0012459709087449999;
            weights[51] = 0.0012459709087449999;
            weights[52] = 0.0012459709087449999;
            weights[53] = 0.0012459709087449999;
            weights[54] = 0.0012459709087449999;
            weights[55] = 0.0091214200595000003;
            weights[56] = 0.0091214200595000003;
            weights[57] = 0.0091214200595000003;
            weights[58] = 0.0091214200595000003;
            weights[59] = 0.0091214200595000003;
            weights[60] = 0.0091214200595000003;
            weights[61] = 0.0051292818681000002;
            weights[62] = 0.0051292818681000002;
            weights[63] = 0.0051292818681000002;
            weights[64] = 0.0051292818681000002;
            weights[65] = 0.0051292818681000002;
            weights[66] = 0.0051292818681000002;
            weights[67] = 0.0018999644276499999;
            weights[68] = 0.0018999644276499999;
            weights[69] = 0.0018999644276499999;
            weights[70] = 0.0018999644276499999;
            weights[71] = 0.0018999644276499999;
            weights[72] = 0.0018999644276499999;

            break;

        case 20:

            coordinates.resize(79*3);
            weights.resize(79);

            coordinates[0] = 0.33333333333330001;
            coordinates[1] = 0.33333333333330001;
            coordinates[2] = 0;
            coordinates[3] = 0.50095046435199997;
            coordinates[4] = 0.50095046435199997;
            coordinates[5] = 0;
            coordinates[6] = -0.0019009287044;
            coordinates[7] = 0.50095046435199997;
            coordinates[8] = 0;
            coordinates[9] = 0.50095046435199997;
            coordinates[10] = -0.0019009287044;
            coordinates[11] = 0;
            coordinates[12] = 0.48821295793500002;
            coordinates[13] = 0.48821295793500002;
            coordinates[14] = 0;
            coordinates[15] = 0.023574084130499998;
            coordinates[16] = 0.48821295793500002;
            coordinates[17] = 0;
            coordinates[18] = 0.48821295793500002;
            coordinates[19] = 0.023574084130499998;
            coordinates[20] = 0;
            coordinates[21] = 0.45513668694999998;
            coordinates[22] = 0.45513668694999998;
            coordinates[23] = 0;
            coordinates[24] = 0.089726636099400001;
            coordinates[25] = 0.45513668694999998;
            coordinates[26] = 0;
            coordinates[27] = 0.45513668694999998;
            coordinates[28] = 0.089726636099400001;
            coordinates[29] = 0;
            coordinates[30] = 0.40199625931799998;
            coordinates[31] = 0.40199625931799998;
            coordinates[32] = 0;
            coordinates[33] = 0.196007481363;
            coordinates[34] = 0.40199625931799998;
            coordinates[35] = 0;
            coordinates[36] = 0.40199625931799998;
            coordinates[37] = 0.196007481363;
            coordinates[38] = 0;
            coordinates[39] = 0.25589290975899998;
            coordinates[40] = 0.25589290975899998;
            coordinates[41] = 0;
            coordinates[42] = 0.48821418048100002;
            coordinates[43] = 0.25589290975899998;
            coordinates[44] = 0;
            coordinates[45] = 0.25589290975899998;
            coordinates[46] = 0.48821418048100002;
            coordinates[47] = 0;
            coordinates[48] = 0.17648825599500001;
            coordinates[49] = 0.17648825599500001;
            coordinates[50] = 0;
            coordinates[51] = 0.64702348800999998;
            coordinates[52] = 0.17648825599500001;
            coordinates[53] = 0;
            coordinates[54] = 0.17648825599500001;
            coordinates[55] = 0.64702348800999998;
            coordinates[56] = 0;
            coordinates[57] = 0.104170855337;
            coordinates[58] = 0.104170855337;
            coordinates[59] = 0;
            coordinates[60] = 0.79165828932600002;
            coordinates[61] = 0.104170855337;
            coordinates[62] = 0;
            coordinates[63] = 0.104170855337;
            coordinates[64] = 0.79165828932600002;
            coordinates[65] = 0;
            coordinates[66] = 0.053068963840899999;
            coordinates[67] = 0.053068963840899999;
            coordinates[68] = 0;
            coordinates[69] = 0.89386207231799997;
            coordinates[70] = 0.053068963840899999;
            coordinates[71] = 0;
            coordinates[72] = 0.053068963840899999;
            coordinates[73] = 0.89386207231799997;
            coordinates[74] = 0;
            coordinates[75] = 0.041618715196000002;
            coordinates[76] = 0.041618715196000002;
            coordinates[77] = 0;
            coordinates[78] = 0.91676256960799996;
            coordinates[79] = 0.041618715196000002;
            coordinates[80] = 0;
            coordinates[81] = 0.041618715196000002;
            coordinates[82] = 0.91676256960799996;
            coordinates[83] = 0;
            coordinates[84] = 0.0115819214068;
            coordinates[85] = 0.0115819214068;
            coordinates[86] = 0;
            coordinates[87] = 0.97683615718600003;
            coordinates[88] = 0.0115819214068;
            coordinates[89] = 0;
            coordinates[90] = 0.0115819214068;
            coordinates[91] = 0.97683615718600003;
            coordinates[92] = 0;
            coordinates[93] = 0.60640264610600003;
            coordinates[94] = 0.34485577022899999;
            coordinates[95] = 0;
            coordinates[96] = 0.048741583664799998;
            coordinates[97] = 0.60640264610600003;
            coordinates[98] = 0;
            coordinates[99] = 0.34485577022899999;
            coordinates[100] = 0.048741583664799998;
            coordinates[101] = 0;
            coordinates[102] = 0.048741583664799998;
            coordinates[103] = 0.34485577022899999;
            coordinates[104] = 0;
            coordinates[105] = 0.34485577022899999;
            coordinates[106] = 0.60640264610600003;
            coordinates[107] = 0;
            coordinates[108] = 0.60640264610600003;
            coordinates[109] = 0.048741583664799998;
            coordinates[110] = 0;
            coordinates[111] = 0.61584261445699995;
            coordinates[112] = 0.37784326959499998;
            coordinates[113] = 0;
            coordinates[114] = 0.0063141159486000001;
            coordinates[115] = 0.61584261445699995;
            coordinates[116] = 0;
            coordinates[117] = 0.37784326959499998;
            coordinates[118] = 0.0063141159486000001;
            coordinates[119] = 0;
            coordinates[120] = 0.0063141159486000001;
            coordinates[121] = 0.37784326959499998;
            coordinates[122] = 0;
            coordinates[123] = 0.37784326959499998;
            coordinates[124] = 0.61584261445699995;
            coordinates[125] = 0;
            coordinates[126] = 0.61584261445699995;
            coordinates[127] = 0.0063141159486000001;
            coordinates[128] = 0;
            coordinates[129] = 0.55904800039000002;
            coordinates[130] = 0.306635479062;
            coordinates[131] = 0;
            coordinates[132] = 0.134316520547;
            coordinates[133] = 0.55904800039000002;
            coordinates[134] = 0;
            coordinates[135] = 0.306635479062;
            coordinates[136] = 0.134316520547;
            coordinates[137] = 0;
            coordinates[138] = 0.134316520547;
            coordinates[139] = 0.306635479062;
            coordinates[140] = 0;
            coordinates[141] = 0.306635479062;
            coordinates[142] = 0.55904800039000002;
            coordinates[143] = 0;
            coordinates[144] = 0.55904800039000002;
            coordinates[145] = 0.134316520547;
            coordinates[146] = 0;
            coordinates[147] = 0.73660674326300002;
            coordinates[148] = 0.24941936277499999;
            coordinates[149] = 0;
            coordinates[150] = 0.013973893962399999;
            coordinates[151] = 0.73660674326300002;
            coordinates[152] = 0;
            coordinates[153] = 0.24941936277499999;
            coordinates[154] = 0.013973893962399999;
            coordinates[155] = 0;
            coordinates[156] = 0.013973893962399999;
            coordinates[157] = 0.24941936277499999;
            coordinates[158] = 0;
            coordinates[159] = 0.24941936277499999;
            coordinates[160] = 0.73660674326300002;
            coordinates[161] = 0;
            coordinates[162] = 0.73660674326300002;
            coordinates[163] = 0.013973893962399999;
            coordinates[164] = 0;
            coordinates[165] = 0.71167514228700002;
            coordinates[166] = 0.212775724803;
            coordinates[167] = 0;
            coordinates[168] = 0.075549132909800004;
            coordinates[169] = 0.71167514228700002;
            coordinates[170] = 0;
            coordinates[171] = 0.212775724803;
            coordinates[172] = 0.075549132909800004;
            coordinates[173] = 0;
            coordinates[174] = 0.075549132909800004;
            coordinates[175] = 0.212775724803;
            coordinates[176] = 0;
            coordinates[177] = 0.212775724803;
            coordinates[178] = 0.71167514228700002;
            coordinates[179] = 0;
            coordinates[180] = 0.71167514228700002;
            coordinates[181] = 0.075549132909800004;
            coordinates[182] = 0;
            coordinates[183] = 0.86140271715500005;
            coordinates[184] = 0.146965436053;
            coordinates[185] = 0;
            coordinates[186] = -0.0083681532082000003;
            coordinates[187] = 0.86140271715500005;
            coordinates[188] = 0;
            coordinates[189] = 0.146965436053;
            coordinates[190] = -0.0083681532082000003;
            coordinates[191] = 0;
            coordinates[192] = -0.0083681532082000003;
            coordinates[193] = 0.146965436053;
            coordinates[194] = 0;
            coordinates[195] = 0.146965436053;
            coordinates[196] = 0.86140271715500005;
            coordinates[197] = 0;
            coordinates[198] = 0.86140271715500005;
            coordinates[199] = -0.0083681532082000003;
            coordinates[200] = 0;
            coordinates[201] = 0.83558695791199999;
            coordinates[202] = 0.13772697882900001;
            coordinates[203] = 0;
            coordinates[204] = 0.026686063258699998;
            coordinates[205] = 0.83558695791199999;
            coordinates[206] = 0;
            coordinates[207] = 0.13772697882900001;
            coordinates[208] = 0.026686063258699998;
            coordinates[209] = 0;
            coordinates[210] = 0.026686063258699998;
            coordinates[211] = 0.13772697882900001;
            coordinates[212] = 0;
            coordinates[213] = 0.13772697882900001;
            coordinates[214] = 0.83558695791199999;
            coordinates[215] = 0;
            coordinates[216] = 0.83558695791199999;
            coordinates[217] = 0.026686063258699998;
            coordinates[218] = 0;
            coordinates[219] = 0.92975617155699997;
            coordinates[220] = 0.059696109148999997;
            coordinates[221] = 0;
            coordinates[222] = 0.0105477192941;
            coordinates[223] = 0.92975617155699997;
            coordinates[224] = 0;
            coordinates[225] = 0.059696109148999997;
            coordinates[226] = 0.0105477192941;
            coordinates[227] = 0;
            coordinates[228] = 0.0105477192941;
            coordinates[229] = 0.059696109148999997;
            coordinates[230] = 0;
            coordinates[231] = 0.059696109148999997;
            coordinates[232] = 0.92975617155699997;
            coordinates[233] = 0;
            coordinates[234] = 0.92975617155699997;
            coordinates[235] = 0.0105477192941;
            coordinates[236] = 0;

            weights[0] = 0.016528527770800001;
            weights[1] = 0.000433509592831;
            weights[2] = 0.000433509592831;
            weights[3] = 0.000433509592831;
            weights[4] = 0.0058300263582000003;
            weights[5] = 0.0058300263582000003;
            weights[6] = 0.0058300263582000003;
            weights[7] = 0.0114384681782;
            weights[8] = 0.0114384681782;
            weights[9] = 0.0114384681782;
            weights[10] = 0.015224491336950001;
            weights[11] = 0.015224491336950001;
            weights[12] = 0.015224491336950001;
            weights[13] = 0.015312445862699999;
            weights[14] = 0.015312445862699999;
            weights[15] = 0.015312445862699999;
            weights[16] = 0.0121840288384;
            weights[17] = 0.0121840288384;
            weights[18] = 0.0121840288384;
            weights[19] = 0.0079987160159999994;
            weights[20] = 0.0079987160159999994;
            weights[21] = 0.0079987160159999994;
            weights[22] = 0.0038491509078000001;
            weights[23] = 0.0038491509078000001;
            weights[24] = 0.0038491509078000001;
            weights[25] = -0.00031603024874399997;
            weights[26] = -0.00031603024874399997;
            weights[27] = -0.00031603024874399997;
            weights[28] = 0.00087556715059499996;
            weights[29] = 0.00087556715059499996;
            weights[30] = 0.00087556715059499996;
            weights[31] = 0.0082329195947999992;
            weights[32] = 0.0082329195947999992;
            weights[33] = 0.0082329195947999992;
            weights[34] = 0.0082329195947999992;
            weights[35] = 0.0082329195947999992;
            weights[36] = 0.0082329195947999992;
            weights[37] = 0.0024195167702450002;
            weights[38] = 0.0024195167702450002;
            weights[39] = 0.0024195167702450002;
            weights[40] = 0.0024195167702450002;
            weights[41] = 0.0024195167702450002;
            weights[42] = 0.0024195167702450002;
            weights[43] = 0.012902453267349999;
            weights[44] = 0.012902453267349999;
            weights[45] = 0.012902453267349999;
            weights[46] = 0.012902453267349999;
            weights[47] = 0.012902453267349999;
            weights[48] = 0.012902453267349999;
            weights[49] = 0.0042355455272199997;
            weights[50] = 0.0042355455272199997;
            weights[51] = 0.0042355455272199997;
            weights[52] = 0.0042355455272199997;
            weights[53] = 0.0042355455272199997;
            weights[54] = 0.0042355455272199997;
            weights[55] = 0.00917745705315;
            weights[56] = 0.00917745705315;
            weights[57] = 0.00917745705315;
            weights[58] = 0.00917745705315;
            weights[59] = 0.00917745705315;
            weights[60] = 0.00917745705315;
            weights[61] = 0.00035220233895399999;
            weights[62] = 0.00035220233895399999;
            weights[63] = 0.00035220233895399999;
            weights[64] = 0.00035220233895399999;
            weights[65] = 0.00035220233895399999;
            weights[66] = 0.00035220233895399999;
            weights[67] = 0.0050563424637500003;
            weights[68] = 0.0050563424637500003;
            weights[69] = 0.0050563424637500003;
            weights[70] = 0.0050563424637500003;
            weights[71] = 0.0050563424637500003;
            weights[72] = 0.0050563424637500003;
            weights[73] = 0.001786954692975;
            weights[74] = 0.001786954692975;
            weights[75] = 0.001786954692975;
            weights[76] = 0.001786954692975;
            weights[77] = 0.001786954692975;
            weights[78] = 0.001786954692975;

            break;
        
        default:
    
            std::cout << "Error in 'gptriangle' namespace: trying to get Gauss points to integrate order " << integrationorder << " which is undefined (too high)" << std::endl;
            abort();
    }
    
}






